// File generated by CPPExt (Value)
//
//                     Copyright (C) 1991 - 2000 by  
//                      Matra Datavision SA.  All rights reserved.
//  
//                     Copyright (C) 2001 - 2004 by
//                     Open CASCADE SA.  All rights reserved.
// 
// This file is part of the Open CASCADE Technology software.
//
// This software may be distributed and/or modified under the terms and
// conditions of the Open CASCADE Public License as defined by Open CASCADE SA
// and appearing in the file LICENSE included in the packaging of this file.
//  
// This software is distributed on an "AS IS" basis, without warranty of any
// kind, and Open CASCADE SA hereby disclaims all such warranties,
// including without limitation, any warranties of merchantability, fitness
// for a particular purpose or non-infringement. Please see the License for
// the specific terms and conditions governing rights and limitations under the
// License.

#ifndef _AdvApp2Var_Network_HeaderFile
#define _AdvApp2Var_Network_HeaderFile

#ifndef _AdvApp2Var_SequenceOfPatch_HeaderFile
#include <AdvApp2Var_SequenceOfPatch.hxx>
#endif
#ifndef _TColStd_SequenceOfReal_HeaderFile
#include <TColStd_SequenceOfReal.hxx>
#endif
#ifndef _Standard_Boolean_HeaderFile
#include <Standard_Boolean.hxx>
#endif
#ifndef _Standard_Integer_HeaderFile
#include <Standard_Integer.hxx>
#endif
#ifndef _Standard_Real_HeaderFile
#include <Standard_Real.hxx>
#endif
class Standard_NoSuchObject;
class AdvApp2Var_SequenceOfPatch;
class TColStd_SequenceOfReal;
class AdvApp2Var_Patch;


#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif
#ifndef _Standard_Macro_HeaderFile
#include <Standard_Macro.hxx>
#endif


class AdvApp2Var_Network  {

public:

    void* operator new(size_t,void* anAddress) 
      {
        return anAddress;
      }
    void* operator new(size_t size) 
      { 
        return Standard::Allocate(size); 
      }
    void  operator delete(void *anAddress) 
      { 
        if (anAddress) Standard::Free((Standard_Address&)anAddress); 
      }
 // Methods PUBLIC
 // 


Standard_EXPORT AdvApp2Var_Network();


Standard_EXPORT AdvApp2Var_Network(const AdvApp2Var_SequenceOfPatch& Net,const TColStd_SequenceOfReal& TheU,const TColStd_SequenceOfReal& TheV);

//! search the Index of the first Patch not approximated, <br>
//!          if all Patches are approximated Standard_False is returned <br>
Standard_EXPORT   Standard_Boolean FirstNotApprox(Standard_Integer& Index) const;

  AdvApp2Var_Patch& ChangePatch(const Standard_Integer Index) ;
  AdvApp2Var_Patch& operator()(const Standard_Integer Index) 
{
  return ChangePatch(Index);
}



Standard_EXPORT   void UpdateInU(const Standard_Real CuttingValue) ;


Standard_EXPORT   void UpdateInV(const Standard_Real CuttingValue) ;


Standard_EXPORT   void SameDegree(const Standard_Integer iu,const Standard_Integer iv,Standard_Integer& ncfu,Standard_Integer& ncfv) ;


Standard_EXPORT   Standard_Integer NbPatch() const;


Standard_EXPORT   Standard_Integer NbPatchInU() const;


Standard_EXPORT   Standard_Integer NbPatchInV() const;


Standard_EXPORT   Standard_Real UParameter(const Standard_Integer Index) const;


Standard_EXPORT   Standard_Real VParameter(const Standard_Integer Index) const;

 const AdvApp2Var_Patch& Patch(const Standard_Integer UIndex,const Standard_Integer VIndex) const;
 const AdvApp2Var_Patch& operator()(const Standard_Integer UIndex,const Standard_Integer VIndex) const
{
  return Patch(UIndex,VIndex);
}






protected:

 // Methods PROTECTED
 // 


 // Fields PROTECTED
 //


private: 

 // Methods PRIVATE
 // 


 // Fields PRIVATE
 //
AdvApp2Var_SequenceOfPatch myNet;
TColStd_SequenceOfReal myUParameters;
TColStd_SequenceOfReal myVParameters;


};


#include <AdvApp2Var_Network.lxx>



// other Inline functions and methods (like "C++: function call" methods)
//


#endif
