// File generated by CPPExt (Value)
//
//                     Copyright (C) 1991 - 2000 by  
//                      Matra Datavision SA.  All rights reserved.
//  
//                     Copyright (C) 2001 - 2004 by
//                     Open CASCADE SA.  All rights reserved.
// 
// This file is part of the Open CASCADE Technology software.
//
// This software may be distributed and/or modified under the terms and
// conditions of the Open CASCADE Public License as defined by Open CASCADE SA
// and appearing in the file LICENSE included in the packaging of this file.
//  
// This software is distributed on an "AS IS" basis, without warranty of any
// kind, and Open CASCADE SA hereby disclaims all such warranties,
// including without limitation, any warranties of merchantability, fitness
// for a particular purpose or non-infringement. Please see the License for
// the specific terms and conditions governing rights and limitations under the
// License.

#ifndef _BOPTools_PaveSet_HeaderFile
#define _BOPTools_PaveSet_HeaderFile

#ifndef _BOPTools_ListOfPave_HeaderFile
#include <BOPTools_ListOfPave.hxx>
#endif
class BOPTools_ListOfPave;
class BOPTools_Pave;


#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif
#ifndef _Standard_Macro_HeaderFile
#include <Standard_Macro.hxx>
#endif


//! class for storing/sorting paves that <br>
//! belong to an edge <br>
class BOPTools_PaveSet  {

public:

    void* operator new(size_t,void* anAddress) 
      {
        return anAddress;
      }
    void* operator new(size_t size) 
      { 
        return Standard::Allocate(size); 
      }
    void  operator delete(void *anAddress) 
      { 
        if (anAddress) Standard::Free((Standard_Address&)anAddress); 
      }
 // Methods PUBLIC
 // 


//! Empty constructor <br>
Standard_EXPORT BOPTools_PaveSet();


//! Access to the  list <br>
Standard_EXPORT   BOPTools_ListOfPave& ChangeSet() ;


//! Access to the  list const <br>
Standard_EXPORT  const BOPTools_ListOfPave& Set() const;


//! Appends <aPave>  to the  list <br>
Standard_EXPORT   void Append(const BOPTools_Pave& aPave) ;


//! Sorts  list in increasing order of paves' parameters <br>
Standard_EXPORT   void SortSet() ;





protected:

 // Methods PROTECTED
 // 


 // Fields PROTECTED
 //


private: 

 // Methods PRIVATE
 // 


 // Fields PRIVATE
 //
BOPTools_ListOfPave myPaveList;


};





// other Inline functions and methods (like "C++: function call" methods)
//


#endif
