// File generated by CPPExt (Value)
//
//                     Copyright (C) 1991 - 2000 by  
//                      Matra Datavision SA.  All rights reserved.
//  
//                     Copyright (C) 2001 - 2004 by
//                     Open CASCADE SA.  All rights reserved.
// 
// This file is part of the Open CASCADE Technology software.
//
// This software may be distributed and/or modified under the terms and
// conditions of the Open CASCADE Public License as defined by Open CASCADE SA
// and appearing in the file LICENSE included in the packaging of this file.
//  
// This software is distributed on an "AS IS" basis, without warranty of any
// kind, and Open CASCADE SA hereby disclaims all such warranties,
// including without limitation, any warranties of merchantability, fitness
// for a particular purpose or non-infringement. Please see the License for
// the specific terms and conditions governing rights and limitations under the
// License.

#ifndef _BRepBlend_Chamfer_HeaderFile
#define _BRepBlend_Chamfer_HeaderFile

#ifndef _Handle_Adaptor3d_HSurface_HeaderFile
#include <Handle_Adaptor3d_HSurface.hxx>
#endif
#ifndef _Handle_Adaptor3d_HCurve_HeaderFile
#include <Handle_Adaptor3d_HCurve.hxx>
#endif
#ifndef _Standard_Integer_HeaderFile
#include <Standard_Integer.hxx>
#endif
#ifndef _Standard_Real_HeaderFile
#include <Standard_Real.hxx>
#endif
#ifndef _BRepBlend_Corde_HeaderFile
#include <BRepBlend_Corde.hxx>
#endif
#ifndef _Blend_Function_HeaderFile
#include <Blend_Function.hxx>
#endif
#ifndef _Standard_Boolean_HeaderFile
#include <Standard_Boolean.hxx>
#endif
#ifndef _GeomAbs_Shape_HeaderFile
#include <GeomAbs_Shape.hxx>
#endif
class Adaptor3d_HSurface;
class Adaptor3d_HCurve;
class BRepBlend_HCurveTool;
class BRepBlend_HSurfaceTool;
class BRepBlend_Corde;
class math_Vector;
class math_Matrix;
class gp_Pnt;
class gp_Vec;
class gp_Vec2d;
class TColStd_Array1OfReal;
class TColStd_Array1OfInteger;
class gp_Lin;
class Blend_Point;
class TColgp_Array1OfPnt;
class TColgp_Array1OfVec;
class TColgp_Array1OfPnt2d;
class TColgp_Array1OfVec2d;


#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif
#ifndef _Standard_Macro_HeaderFile
#include <Standard_Macro.hxx>
#endif


class BRepBlend_Chamfer  : public Blend_Function {

public:

    void* operator new(size_t,void* anAddress) 
      {
        return anAddress;
      }
    void* operator new(size_t size) 
      { 
        return Standard::Allocate(size); 
      }
    void  operator delete(void *anAddress) 
      { 
        if (anAddress) Standard::Free((Standard_Address&)anAddress); 
      }
 // Methods PUBLIC
 // 


Standard_EXPORT BRepBlend_Chamfer(const Handle(Adaptor3d_HSurface)& S1,const Handle(Adaptor3d_HSurface)& S2,const Handle(Adaptor3d_HCurve)& CG);


Standard_EXPORT   Standard_Integer NbEquations() const;


Standard_EXPORT   Standard_Boolean Value(const math_Vector& X,math_Vector& F) ;


Standard_EXPORT   Standard_Boolean Derivatives(const math_Vector& X,math_Matrix& D) ;


Standard_EXPORT   Standard_Boolean Values(const math_Vector& X,math_Vector& F,math_Matrix& D) ;


Standard_EXPORT   void Set(const Standard_Real Param) ;


Standard_EXPORT   void Set(const Standard_Real First,const Standard_Real Last) ;


Standard_EXPORT   void GetTolerance(math_Vector& Tolerance,const Standard_Real Tol) const;


Standard_EXPORT   void GetBounds(math_Vector& InfBound,math_Vector& SupBound) const;


Standard_EXPORT   Standard_Boolean IsSolution(const math_Vector& Sol,const Standard_Real Tol) ;


Standard_EXPORT   Standard_Real GetMinimalDistance() const;


Standard_EXPORT  const gp_Pnt& PointOnS1() const;


Standard_EXPORT  const gp_Pnt& PointOnS2() const;


Standard_EXPORT   Standard_Boolean IsTangencyPoint() const;


Standard_EXPORT  const gp_Vec& TangentOnS1() const;


Standard_EXPORT  const gp_Vec2d& Tangent2dOnS1() const;


Standard_EXPORT  const gp_Vec& TangentOnS2() const;


Standard_EXPORT  const gp_Vec2d& Tangent2dOnS2() const;


Standard_EXPORT   void Tangent(const Standard_Real U1,const Standard_Real V1,const Standard_Real U2,const Standard_Real V2,gp_Vec& TgFirst,gp_Vec& TgLast,gp_Vec& NormFirst,gp_Vec& NormLast) const;


Standard_EXPORT   void Set(const Standard_Real Dist1,const Standard_Real Dist2,const Standard_Integer Choix) ;


Standard_EXPORT   Standard_Boolean IsRational() const;


Standard_EXPORT   Standard_Real GetSectionSize() const;


Standard_EXPORT   void GetMinimalWeight(TColStd_Array1OfReal& Weigths) const;


Standard_EXPORT   Standard_Integer NbIntervals(const GeomAbs_Shape S) const;


Standard_EXPORT   void Intervals(TColStd_Array1OfReal& T,const GeomAbs_Shape S) const;


Standard_EXPORT   void GetShape(Standard_Integer& NbPoles,Standard_Integer& NbKnots,Standard_Integer& Degree,Standard_Integer& NbPoles2d) ;


Standard_EXPORT   void GetTolerance(const Standard_Real BoundTol,const Standard_Real SurfTol,const Standard_Real AngleTol,math_Vector& Tol3d,math_Vector& Tol1D) const;


Standard_EXPORT   void Knots(TColStd_Array1OfReal& TKnots) ;


Standard_EXPORT   void Mults(TColStd_Array1OfInteger& TMults) ;


Standard_EXPORT   void Section(const Standard_Real Param,const Standard_Real U1,const Standard_Real V1,const Standard_Real U2,const Standard_Real V2,Standard_Real& Pdeb,Standard_Real& Pfin,gp_Lin& C) ;


Standard_EXPORT   Standard_Boolean Section(const Blend_Point& P,TColgp_Array1OfPnt& Poles,TColgp_Array1OfVec& DPoles,TColgp_Array1OfVec& D2Poles,TColgp_Array1OfPnt2d& Poles2d,TColgp_Array1OfVec2d& DPoles2d,TColgp_Array1OfVec2d& D2Poles2d,TColStd_Array1OfReal& Weigths,TColStd_Array1OfReal& DWeigths,TColStd_Array1OfReal& D2Weigths) ;


Standard_EXPORT   Standard_Boolean Section(const Blend_Point& P,TColgp_Array1OfPnt& Poles,TColgp_Array1OfVec& DPoles,TColgp_Array1OfPnt2d& Poles2d,TColgp_Array1OfVec2d& DPoles2d,TColStd_Array1OfReal& Weigths,TColStd_Array1OfReal& DWeigths) ;


Standard_EXPORT   void Section(const Blend_Point& P,TColgp_Array1OfPnt& Poles,TColgp_Array1OfPnt2d& Poles2d,TColStd_Array1OfReal& Weigths) ;


Standard_EXPORT   void Resolution(const Standard_Integer IC2d,const Standard_Real Tol,Standard_Real& TolU,Standard_Real& TolV) const;





protected:

 // Methods PROTECTED
 // 


 // Fields PROTECTED
 //


private: 

 // Methods PRIVATE
 // 


 // Fields PRIVATE
 //
Handle_Adaptor3d_HSurface surf1;
Handle_Adaptor3d_HSurface surf2;
Handle_Adaptor3d_HCurve curv;
Standard_Integer choix;
Standard_Real tol;
Standard_Real distmin;
BRepBlend_Corde corde1;
BRepBlend_Corde corde2;


};





// other Inline functions and methods (like "C++: function call" methods)
//


#endif
