// File generated by CPPExt (Value)
//
//                     Copyright (C) 1991 - 2000 by  
//                      Matra Datavision SA.  All rights reserved.
//  
//                     Copyright (C) 2001 - 2004 by
//                     Open CASCADE SA.  All rights reserved.
// 
// This file is part of the Open CASCADE Technology software.
//
// This software may be distributed and/or modified under the terms and
// conditions of the Open CASCADE Public License as defined by Open CASCADE SA
// and appearing in the file LICENSE included in the packaging of this file.
//  
// This software is distributed on an "AS IS" basis, without warranty of any
// kind, and Open CASCADE SA hereby disclaims all such warranties,
// including without limitation, any warranties of merchantability, fitness
// for a particular purpose or non-infringement. Please see the License for
// the specific terms and conditions governing rights and limitations under the
// License.

#ifndef _BRepCheck_HeaderFile
#define _BRepCheck_HeaderFile

#ifndef _BRepCheck_Status_HeaderFile
#include <BRepCheck_Status.hxx>
#endif
#ifndef _Standard_OStream_HeaderFile
#include <Standard_OStream.hxx>
#endif
#ifndef _Standard_Boolean_HeaderFile
#include <Standard_Boolean.hxx>
#endif
class BRepCheck_ListOfStatus;
class TopoDS_Wire;
class TopoDS_Face;
class TopoDS_Edge;
class BRepCheck_Result;
class BRepCheck_Vertex;
class BRepCheck_Edge;
class BRepCheck_Wire;
class BRepCheck_Face;
class BRepCheck_Shell;
class BRepCheck_Analyzer;
class BRepCheck_ListOfStatus;
class BRepCheck_DataMapOfShapeListOfStatus;
class BRepCheck_DataMapOfShapeResult;
class BRepCheck_ListNodeOfListOfStatus;
class BRepCheck_ListIteratorOfListOfStatus;
class BRepCheck_DataMapNodeOfDataMapOfShapeListOfStatus;
class BRepCheck_DataMapIteratorOfDataMapOfShapeListOfStatus;
class BRepCheck_DataMapNodeOfDataMapOfShapeResult;
class BRepCheck_DataMapIteratorOfDataMapOfShapeResult;


#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif
#ifndef _Standard_Macro_HeaderFile
#include <Standard_Macro.hxx>
#endif

//! This package  provides tools to check the validity <br>
//!          of the BRep. <br>
class BRepCheck  {

public:

    void* operator new(size_t,void* anAddress) 
      {
        return anAddress;
      }
    void* operator new(size_t size) 
      { 
        return Standard::Allocate(size); 
      }
    void  operator delete(void *anAddress) 
      { 
        if (anAddress) Standard::Free((Standard_Address&)anAddress); 
      }
 // Methods PUBLIC
 // 


Standard_EXPORT static  void Add(BRepCheck_ListOfStatus& List,const BRepCheck_Status Stat) ;


Standard_EXPORT static  void Print(const BRepCheck_Status Stat,Standard_OStream& OS) ;


Standard_EXPORT static  Standard_Boolean SelfIntersection(const TopoDS_Wire& W,const TopoDS_Face& F,TopoDS_Edge& E1,TopoDS_Edge& E2) ;





protected:

 // Methods PROTECTED
 // 


 // Fields PROTECTED
 //


private: 

 // Methods PRIVATE
 // 


 // Fields PRIVATE
 //

friend class BRepCheck_Result;
friend class BRepCheck_Vertex;
friend class BRepCheck_Edge;
friend class BRepCheck_Wire;
friend class BRepCheck_Face;
friend class BRepCheck_Shell;
friend class BRepCheck_Analyzer;
friend class BRepCheck_ListOfStatus;
friend class BRepCheck_DataMapOfShapeListOfStatus;
friend class BRepCheck_DataMapOfShapeResult;
friend class BRepCheck_ListNodeOfListOfStatus;
friend class BRepCheck_ListIteratorOfListOfStatus;
friend class BRepCheck_DataMapNodeOfDataMapOfShapeListOfStatus;
friend class BRepCheck_DataMapIteratorOfDataMapOfShapeListOfStatus;
friend class BRepCheck_DataMapNodeOfDataMapOfShapeResult;
friend class BRepCheck_DataMapIteratorOfDataMapOfShapeResult;

};





// other Inline functions and methods (like "C++: function call" methods)
//


#endif
