// File generated by CPPExt (Value)
//
//                     Copyright (C) 1991 - 2000 by  
//                      Matra Datavision SA.  All rights reserved.
//  
//                     Copyright (C) 2001 - 2004 by
//                     Open CASCADE SA.  All rights reserved.
// 
// This file is part of the Open CASCADE Technology software.
//
// This software may be distributed and/or modified under the terms and
// conditions of the Open CASCADE Public License as defined by Open CASCADE SA
// and appearing in the file LICENSE included in the packaging of this file.
//  
// This software is distributed on an "AS IS" basis, without warranty of any
// kind, and Open CASCADE SA hereby disclaims all such warranties,
// including without limitation, any warranties of merchantability, fitness
// for a particular purpose or non-infringement. Please see the License for
// the specific terms and conditions governing rights and limitations under the
// License.

#ifndef _BRepGProp_Domain_HeaderFile
#define _BRepGProp_Domain_HeaderFile

#ifndef _TopExp_Explorer_HeaderFile
#include <TopExp_Explorer.hxx>
#endif
#ifndef _Standard_Boolean_HeaderFile
#include <Standard_Boolean.hxx>
#endif
class TopoDS_Face;
class TopoDS_Edge;


#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif
#ifndef _Standard_Macro_HeaderFile
#include <Standard_Macro.hxx>
#endif

//! Arc iterator. Returns only Forward and Reversed edges from <br>
//!          the face in an undigested order. <br>
class BRepGProp_Domain  {

public:

    void* operator new(size_t,void* anAddress) 
      {
        return anAddress;
      }
    void* operator new(size_t size) 
      { 
        return Standard::Allocate(size); 
      }
    void  operator delete(void *anAddress) 
      { 
        if (anAddress) Standard::Free((Standard_Address&)anAddress); 
      }
 // Methods PUBLIC
 // 
//! Empty constructor. <br>
BRepGProp_Domain();
//! Constructor. Initializes the domain with the face. <br>
BRepGProp_Domain(const TopoDS_Face& F);
//! Initializes the domain with the face. <br>
  void Init(const TopoDS_Face& F) ;

//!  Returns True if there is another arc of curve in the list. <br>
  Standard_Boolean More() ;
//! Initializes the exploration with the face already set. <br>
  void Init() ;
//! Returns the current edge. <br>
 const TopoDS_Edge& Value() ;


//!  Sets the index of the arc iterator to the next arc of <br>
//!  curve. <br>
Standard_EXPORT   void Next() ;





protected:

 // Methods PROTECTED
 // 


 // Fields PROTECTED
 //


private: 

 // Methods PRIVATE
 // 


 // Fields PRIVATE
 //
TopExp_Explorer myExplorer;


};


#include <BRepGProp_Domain.lxx>



// other Inline functions and methods (like "C++: function call" methods)
//


#endif
