// File generated by CPPExt (Enum)
//
//                     Copyright (C) 1991 - 2000 by  
//                      Matra Datavision SA.  All rights reserved.
//  
//                     Copyright (C) 2001 - 2004 by
//                     Open CASCADE SA.  All rights reserved.
// 
// This file is part of the Open CASCADE Technology software.
//
// This software may be distributed and/or modified under the terms and
// conditions of the Open CASCADE Public License as defined by Open CASCADE SA
// and appearing in the file LICENSE included in the packaging of this file.
//  
// This software is distributed on an "AS IS" basis, without warranty of any
// kind, and Open CASCADE SA hereby disclaims all such warranties,
// including without limitation, any warranties of merchantability, fitness
// for a particular purpose or non-infringement. Please see the License for
// the specific terms and conditions governing rights and limitations under the
// License.

#ifndef _BRepOffset_Status_HeaderFile
#define _BRepOffset_Status_HeaderFile


//! Lists the offset modes. These are the following: <br>
//! - BRepOffset_Skin which describes the offset along <br>
//!   the surface of a solid, used to obtain a manifold topological space, <br>
//! - BRepOffset_Pipe which describes the offset of a <br>
//!   curve, used to obtain a pre-surface, <br>
//! - BRepOffset_RectoVerso which describes the offset <br>
//!   of a given surface shell along both sides of the surface. <br>//! status of an offset face <br>
//!          Good : <br>
//!          Reversed : e.g. Offset > Radius of a cylinder <br>
//!          Degenerated : e.g. Offset = Radius of a cylinder <br>
//!          Unknown : e.g. for a Beziersurf <br>
enum BRepOffset_Status { 
 BRepOffset_Good,
BRepOffset_Reversed,
BRepOffset_Degenerated,
BRepOffset_Unknown
};


#ifndef _Standard_PrimitiveTypes_HeaderFile
#include <Standard_PrimitiveTypes.hxx>
#endif

#endif
