// File generated by CPPExt (Transient)
//
//
//                     Copyright (C) 1991 - 2000 by  
//                      Matra Datavision SA.  All rights reserved.
//  
//                     Copyright (C) 2001 - 2004 by
//                     Open CASCADE SA.  All rights reserved.
// 
// This file is part of the Open CASCADE Technology software.
//
// This software may be distributed and/or modified under the terms and
// conditions of the Open CASCADE Public License as defined by Open CASCADE SA
// and appearing in the file LICENSE included in the packaging of this file.
//  
// This software is distributed on an "AS IS" basis, without warranty of any
// kind, and Open CASCADE SA hereby disclaims all such warranties,
// including without limitation, any warranties of merchantability, fitness
// for a particular purpose or non-infringement. Please see the License for
// the specific terms and conditions governing rights and limitations under the
// License.

#ifndef _BRep_CurveOnSurface_HeaderFile
#define _BRep_CurveOnSurface_HeaderFile

#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif
#ifndef _Handle_BRep_CurveOnSurface_HeaderFile
#include <Handle_BRep_CurveOnSurface.hxx>
#endif

#ifndef _Handle_Geom2d_Curve_HeaderFile
#include <Handle_Geom2d_Curve.hxx>
#endif
#ifndef _Handle_Geom_Surface_HeaderFile
#include <Handle_Geom_Surface.hxx>
#endif
#ifndef _gp_Pnt2d_HeaderFile
#include <gp_Pnt2d.hxx>
#endif
#ifndef _Bnd_Box2d_HeaderFile
#include <Bnd_Box2d.hxx>
#endif
#ifndef _BRep_GCurve_HeaderFile
#include <BRep_GCurve.hxx>
#endif
#ifndef _Standard_Real_HeaderFile
#include <Standard_Real.hxx>
#endif
#ifndef _Standard_Boolean_HeaderFile
#include <Standard_Boolean.hxx>
#endif
#ifndef _Handle_BRep_CurveRepresentation_HeaderFile
#include <Handle_BRep_CurveRepresentation.hxx>
#endif
class Geom2d_Curve;
class Geom_Surface;
class TopLoc_Location;
class gp_Pnt2d;
class Bnd_Box2d;
class gp_Pnt;
class BRep_CurveRepresentation;


//! Representation  of a  curve   by a   curve  in the <br>
//!          parametric space of a surface. <br>
class BRep_CurveOnSurface : public BRep_GCurve {

public:
 // Methods PUBLIC
 // 


Standard_EXPORT BRep_CurveOnSurface(const Handle(Geom2d_Curve)& PC,const Handle(Geom_Surface)& S,const TopLoc_Location& L);

  void SetUVPoints(const gp_Pnt2d& P1,const gp_Pnt2d& P2) ;

  void UVPoints(gp_Pnt2d& P1,gp_Pnt2d& P2) const;

 const Bnd_Box2d& Box() const;

  Bnd_Box2d& ChangeBox() ;

//! Computes the point at parameter U. <br>
Standard_EXPORT   void D0(const Standard_Real U,gp_Pnt& P) const;

//! Returns True. <br>
Standard_EXPORT virtual  Standard_Boolean IsCurveOnSurface() const;

//! A curve in the parametric space of a surface. <br>
Standard_EXPORT virtual  Standard_Boolean IsCurveOnSurface(const Handle(Geom_Surface)& S,const TopLoc_Location& L) const;


Standard_EXPORT virtual const Handle_Geom_Surface& Surface() const;


Standard_EXPORT virtual const Handle_Geom2d_Curve& PCurve() const;


Standard_EXPORT virtual  void PCurve(const Handle(Geom2d_Curve)& C) ;

//! Return a copy of this representation. <br>
Standard_EXPORT virtual  Handle_BRep_CurveRepresentation Copy() const;

//! Recomputes any derived data after a modification. <br>
//!          This is called when the range is modified. <br>
Standard_EXPORT virtual  void Update() ;
//Standard_EXPORT ~BRep_CurveOnSurface();




 // Type management
 //
 Standard_EXPORT const Handle(Standard_Type)& DynamicType() const;
 //Standard_EXPORT Standard_Boolean	       IsKind(const Handle(Standard_Type)&) const;

protected:

 // Methods PROTECTED
 // 


 // Fields PROTECTED
 //
gp_Pnt2d myUV1;
gp_Pnt2d myUV2;
Bnd_Box2d myBox;


private: 

 // Methods PRIVATE
 // 


 // Fields PRIVATE
 //
Handle_Geom2d_Curve myPCurve;
Handle_Geom_Surface mySurface;


};


#include <BRep_CurveOnSurface.lxx>



// other Inline functions and methods (like "C++: function call" methods)
//


#endif
