// File generated by CPPExt (Transient)
//
//
//                     Copyright (C) 1991 - 2000 by  
//                      Matra Datavision SA.  All rights reserved.
//  
//                     Copyright (C) 2001 - 2004 by
//                     Open CASCADE SA.  All rights reserved.
// 
// This file is part of the Open CASCADE Technology software.
//
// This software may be distributed and/or modified under the terms and
// conditions of the Open CASCADE Public License as defined by Open CASCADE SA
// and appearing in the file LICENSE included in the packaging of this file.
//  
// This software is distributed on an "AS IS" basis, without warranty of any
// kind, and Open CASCADE SA hereby disclaims all such warranties,
// including without limitation, any warranties of merchantability, fitness
// for a particular purpose or non-infringement. Please see the License for
// the specific terms and conditions governing rights and limitations under the
// License.

#ifndef _BRep_PolygonOnSurface_HeaderFile
#define _BRep_PolygonOnSurface_HeaderFile

#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif
#ifndef _Handle_BRep_PolygonOnSurface_HeaderFile
#include <Handle_BRep_PolygonOnSurface.hxx>
#endif

#ifndef _Handle_Poly_Polygon2D_HeaderFile
#include <Handle_Poly_Polygon2D.hxx>
#endif
#ifndef _Handle_Geom_Surface_HeaderFile
#include <Handle_Geom_Surface.hxx>
#endif
#ifndef _BRep_CurveRepresentation_HeaderFile
#include <BRep_CurveRepresentation.hxx>
#endif
#ifndef _Standard_Boolean_HeaderFile
#include <Standard_Boolean.hxx>
#endif
#ifndef _Handle_BRep_CurveRepresentation_HeaderFile
#include <Handle_BRep_CurveRepresentation.hxx>
#endif
class Poly_Polygon2D;
class Geom_Surface;
class Standard_DomainError;
class TopLoc_Location;
class BRep_CurveRepresentation;


//! Representation of a 2D polygon in the parametric <br>
//!          space of a surface. <br>
class BRep_PolygonOnSurface : public BRep_CurveRepresentation {

public:
 // Methods PUBLIC
 // 


Standard_EXPORT BRep_PolygonOnSurface(const Handle(Poly_Polygon2D)& P,const Handle(Geom_Surface)& S,const TopLoc_Location& L);

//! A   2D polygon  representation  in the  parametric <br>
//!          space of a surface. <br>
Standard_EXPORT virtual  Standard_Boolean IsPolygonOnSurface() const;

//! A   2D polygon  representation  in the  parametric <br>
//!          space of a surface. <br>
Standard_EXPORT virtual  Standard_Boolean IsPolygonOnSurface(const Handle(Geom_Surface)& S,const TopLoc_Location& L) const;


Standard_EXPORT virtual const Handle_Geom_Surface& Surface() const;


Standard_EXPORT virtual const Handle_Poly_Polygon2D& Polygon() const;


Standard_EXPORT virtual  void Polygon(const Handle(Poly_Polygon2D)& P) ;

//! Return a copy of this representation. <br>
Standard_EXPORT virtual  Handle_BRep_CurveRepresentation Copy() const;
//Standard_EXPORT ~BRep_PolygonOnSurface();




 // Type management
 //
 Standard_EXPORT const Handle(Standard_Type)& DynamicType() const;
 //Standard_EXPORT Standard_Boolean	       IsKind(const Handle(Standard_Type)&) const;

protected:

 // Methods PROTECTED
 // 


 // Fields PROTECTED
 //


private: 

 // Methods PRIVATE
 // 


 // Fields PRIVATE
 //
Handle_Poly_Polygon2D myPolygon2D;
Handle_Geom_Surface mySurface;


};





// other Inline functions and methods (like "C++: function call" methods)
//


#endif
