// File generated by CPPExt (Value)
//
//                     Copyright (C) 1991 - 2000 by  
//                      Matra Datavision SA.  All rights reserved.
//  
//                     Copyright (C) 2001 - 2004 by
//                     Open CASCADE SA.  All rights reserved.
// 
// This file is part of the Open CASCADE Technology software.
//
// This software may be distributed and/or modified under the terms and
// conditions of the Open CASCADE Public License as defined by Open CASCADE SA
// and appearing in the file LICENSE included in the packaging of this file.
//  
// This software is distributed on an "AS IS" basis, without warranty of any
// kind, and Open CASCADE SA hereby disclaims all such warranties,
// including without limitation, any warranties of merchantability, fitness
// for a particular purpose or non-infringement. Please see the License for
// the specific terms and conditions governing rights and limitations under the
// License.

#ifndef _BooleanOperations_Explorer_HeaderFile
#define _BooleanOperations_Explorer_HeaderFile

#ifndef _BooleanOperations_PShapesDataStructure_HeaderFile
#include <BooleanOperations_PShapesDataStructure.hxx>
#endif
#ifndef _Standard_Address_HeaderFile
#include <Standard_Address.hxx>
#endif
#ifndef _Standard_Integer_HeaderFile
#include <Standard_Integer.hxx>
#endif
#ifndef _TopAbs_ShapeEnum_HeaderFile
#include <TopAbs_ShapeEnum.hxx>
#endif
#ifndef _Standard_Boolean_HeaderFile
#include <Standard_Boolean.hxx>
#endif
#ifndef _Standard_OStream_HeaderFile
#include <Standard_OStream.hxx>
#endif
class BooleanOperations_ShapesDataStructure;


#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif
#ifndef _Standard_Macro_HeaderFile
#include <Standard_Macro.hxx>
#endif

//!  the explorer associated  to the Data Structure to <br>
//!          retrieve   subshapes of a  given   shape stored in <br>
//!          ShapesDataStructure. <br>
class BooleanOperations_Explorer  {

public:

    void* operator new(size_t,void* anAddress) 
      {
        return anAddress;
      }
    void* operator new(size_t size) 
      { 
        return Standard::Allocate(size); 
      }
    void  operator delete(void *anAddress) 
      { 
        if (anAddress) Standard::Free((Standard_Address&)anAddress); 
      }
 // Methods PUBLIC
 // 


Standard_EXPORT BooleanOperations_Explorer(const BooleanOperations_ShapesDataStructure& SDS);


Standard_EXPORT virtual  void Delete() ;
Standard_EXPORT virtual ~BooleanOperations_Explorer()  {Delete();}


Standard_EXPORT virtual  void Init(const Standard_Integer aShape,const TopAbs_ShapeEnum TargetToFind,const TopAbs_ShapeEnum TargetToAvoid = TopAbs_SHAPE) ;


Standard_EXPORT virtual  void Next() ;


Standard_EXPORT   Standard_Boolean More() const;


Standard_EXPORT virtual  Standard_Integer Current() ;


Standard_EXPORT virtual  void Dump(Standard_OStream& S) const;





protected:

 // Methods PROTECTED
 // 


 // Fields PROTECTED
 //
BooleanOperations_PShapesDataStructure myShapesDataStructure;
Standard_Address myStack;
Standard_Integer myTopOfStack;
Standard_Integer mySizeOfStack;
TopAbs_ShapeEnum myTargetToFind;
TopAbs_ShapeEnum myTargetToAvoid;
Standard_Boolean hasMore;


private: 

 // Methods PRIVATE
 // 


 // Fields PRIVATE
 //


};





// other Inline functions and methods (like "C++: function call" methods)
//


#endif
