// File generated by CPPExt (Value)
//
//                     Copyright (C) 1991 - 2000 by  
//                      Matra Datavision SA.  All rights reserved.
//  
//                     Copyright (C) 2001 - 2004 by
//                     Open CASCADE SA.  All rights reserved.
// 
// This file is part of the Open CASCADE Technology software.
//
// This software may be distributed and/or modified under the terms and
// conditions of the Open CASCADE Public License as defined by Open CASCADE SA
// and appearing in the file LICENSE included in the packaging of this file.
//  
// This software is distributed on an "AS IS" basis, without warranty of any
// kind, and Open CASCADE SA hereby disclaims all such warranties,
// including without limitation, any warranties of merchantability, fitness
// for a particular purpose or non-infringement. Please see the License for
// the specific terms and conditions governing rights and limitations under the
// License.

#ifndef _Geom2dToIGES_Geom2dEntity_HeaderFile
#define _Geom2dToIGES_Geom2dEntity_HeaderFile

#ifndef _Handle_IGESData_IGESModel_HeaderFile
#include <Handle_IGESData_IGESModel.hxx>
#endif
#ifndef _Standard_Real_HeaderFile
#include <Standard_Real.hxx>
#endif
class IGESData_IGESModel;


#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif
#ifndef _Standard_Macro_HeaderFile
#include <Standard_Macro.hxx>
#endif

//! provides methods to transfer Geom2d entity from CASCADE to IGES. <br>
class Geom2dToIGES_Geom2dEntity  {

public:

    void* operator new(size_t,void* anAddress) 
      {
        return anAddress;
      }
    void* operator new(size_t size) 
      { 
        return Standard::Allocate(size); 
      }
    void  operator delete(void *anAddress) 
      { 
        if (anAddress) Standard::Free((Standard_Address&)anAddress); 
      }
 // Methods PUBLIC
 // 

//! Creates a tool Geom2dEntity <br>
Standard_EXPORT Geom2dToIGES_Geom2dEntity();

//! Creates a tool ready to run and sets its <br>
//!         fields as GE's. <br>
Standard_EXPORT Geom2dToIGES_Geom2dEntity(const Geom2dToIGES_Geom2dEntity& GE);

//! Set the value of "TheModel" <br>
Standard_EXPORT   void SetModel(const Handle(IGESData_IGESModel)& model) ;

//! Returns the value of "TheModel" <br>
Standard_EXPORT   Handle_IGESData_IGESModel GetModel() const;

//! Sets the value of the UnitFlag <br>
Standard_EXPORT   void SetUnit(const Standard_Real unit) ;

//! Returns the value of the UnitFlag of the header of the model <br>
//!           in millimeters. <br>
Standard_EXPORT   Standard_Real GetUnit() const;





protected:

 // Methods PROTECTED
 // 


 // Fields PROTECTED
 //


private: 

 // Methods PRIVATE
 // 


 // Fields PRIVATE
 //
Handle_IGESData_IGESModel TheModel;
Standard_Real TheUnitFactor;


};





// other Inline functions and methods (like "C++: function call" methods)
//


#endif
