// File generated by CPPExt (Value)
//
//                     Copyright (C) 1991 - 2000 by  
//                      Matra Datavision SA.  All rights reserved.
//  
//                     Copyright (C) 2001 - 2004 by
//                     Open CASCADE SA.  All rights reserved.
// 
// This file is part of the Open CASCADE Technology software.
//
// This software may be distributed and/or modified under the terms and
// conditions of the Open CASCADE Public License as defined by Open CASCADE SA
// and appearing in the file LICENSE included in the packaging of this file.
//  
// This software is distributed on an "AS IS" basis, without warranty of any
// kind, and Open CASCADE SA hereby disclaims all such warranties,
// including without limitation, any warranties of merchantability, fitness
// for a particular purpose or non-infringement. Please see the License for
// the specific terms and conditions governing rights and limitations under the
// License.

#ifndef _Geom2dToIGES_Geom2dPoint_HeaderFile
#define _Geom2dToIGES_Geom2dPoint_HeaderFile

#ifndef _Geom2dToIGES_Geom2dEntity_HeaderFile
#include <Geom2dToIGES_Geom2dEntity.hxx>
#endif
#ifndef _Handle_IGESGeom_Point_HeaderFile
#include <Handle_IGESGeom_Point.hxx>
#endif
#ifndef _Handle_Geom2d_Point_HeaderFile
#include <Handle_Geom2d_Point.hxx>
#endif
#ifndef _Handle_Geom2d_CartesianPoint_HeaderFile
#include <Handle_Geom2d_CartesianPoint.hxx>
#endif
class Geom2dToIGES_Geom2dEntity;
class IGESGeom_Point;
class Geom2d_Point;
class Geom2d_CartesianPoint;


#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif
#ifndef _Standard_Macro_HeaderFile
#include <Standard_Macro.hxx>
#endif

//! This class implements the transfer of the Point Entity from Geom2d <br>
//!          to IGES . These are : <br>
//!          . 2dPoint <br>
//!              * 2dCartesianPoint <br>
class Geom2dToIGES_Geom2dPoint  : public Geom2dToIGES_Geom2dEntity {

public:

    void* operator new(size_t,void* anAddress) 
      {
        return anAddress;
      }
    void* operator new(size_t size) 
      { 
        return Standard::Allocate(size); 
      }
    void  operator delete(void *anAddress) 
      { 
        if (anAddress) Standard::Free((Standard_Address&)anAddress); 
      }
 // Methods PUBLIC
 // 


Standard_EXPORT Geom2dToIGES_Geom2dPoint();

//! Creates a tool Geom2dPoint ready to run and sets its <br>
//!         fields as G2dE's. <br>
Standard_EXPORT Geom2dToIGES_Geom2dPoint(const Geom2dToIGES_Geom2dEntity& G2dE);

//!  Transfert  a  Point from Geom to IGES. If this <br>
//!            Entity could not be converted, this member returns a NullEntity. <br>
Standard_EXPORT   Handle_IGESGeom_Point Transfer2dPoint(const Handle(Geom2d_Point)& start) ;

//!  Transfert  a  CartesianPoint from Geom to IGES. If this <br>
//!            Entity could not be converted, this member returns a NullEntity. <br>
Standard_EXPORT   Handle_IGESGeom_Point Transfer2dPoint(const Handle(Geom2d_CartesianPoint)& start) ;





protected:

 // Methods PROTECTED
 // 


 // Fields PROTECTED
 //


private: 

 // Methods PRIVATE
 // 


 // Fields PRIVATE
 //


};





// other Inline functions and methods (like "C++: function call" methods)
//


#endif
