// File generated by CPPExt (Value)
//
//                     Copyright (C) 1991 - 2000 by  
//                      Matra Datavision SA.  All rights reserved.
//  
//                     Copyright (C) 2001 - 2004 by
//                     Open CASCADE SA.  All rights reserved.
// 
// This file is part of the Open CASCADE Technology software.
//
// This software may be distributed and/or modified under the terms and
// conditions of the Open CASCADE Public License as defined by Open CASCADE SA
// and appearing in the file LICENSE included in the packaging of this file.
//  
// This software is distributed on an "AS IS" basis, without warranty of any
// kind, and Open CASCADE SA hereby disclaims all such warranties,
// including without limitation, any warranties of merchantability, fitness
// for a particular purpose or non-infringement. Please see the License for
// the specific terms and conditions governing rights and limitations under the
// License.

#ifndef _GeomFill_LocFunction_HeaderFile
#define _GeomFill_LocFunction_HeaderFile

#ifndef _Handle_GeomFill_LocationLaw_HeaderFile
#include <Handle_GeomFill_LocationLaw.hxx>
#endif
#ifndef _TColgp_Array1OfVec_HeaderFile
#include <TColgp_Array1OfVec.hxx>
#endif
#ifndef _gp_Mat_HeaderFile
#include <gp_Mat.hxx>
#endif
#ifndef _Standard_Boolean_HeaderFile
#include <Standard_Boolean.hxx>
#endif
#ifndef _Standard_Real_HeaderFile
#include <Standard_Real.hxx>
#endif
#ifndef _Standard_Integer_HeaderFile
#include <Standard_Integer.hxx>
#endif
class GeomFill_LocationLaw;


#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif
#ifndef _Standard_Macro_HeaderFile
#include <Standard_Macro.hxx>
#endif


class GeomFill_LocFunction  {

public:

    void* operator new(size_t,void* anAddress) 
      {
        return anAddress;
      }
    void* operator new(size_t size) 
      { 
        return Standard::Allocate(size); 
      }
    void  operator delete(void *anAddress) 
      { 
        if (anAddress) Standard::Free((Standard_Address&)anAddress); 
      }
 // Methods PUBLIC
 // 


Standard_EXPORT GeomFill_LocFunction(const Handle(GeomFill_LocationLaw)& Law);

//! compute the section for v = param <br>
Standard_EXPORT   Standard_Boolean D0(const Standard_Real Param,const Standard_Real First,const Standard_Real Last) ;

//! compute the first  derivative in v direction  of the <br>
//!           section for v =  param <br>
Standard_EXPORT   Standard_Boolean D1(const Standard_Real Param,const Standard_Real First,const Standard_Real Last) ;

//! compute the second derivative  in v direction of the <br>
//!          section  for v = param <br>
Standard_EXPORT   Standard_Boolean D2(const Standard_Real Param,const Standard_Real First,const Standard_Real Last) ;


Standard_EXPORT   void DN(const Standard_Real Param,const Standard_Real First,const Standard_Real Last,const Standard_Integer Order,Standard_Real& Result,Standard_Integer& Ier) ;





protected:

 // Methods PROTECTED
 // 


 // Fields PROTECTED
 //


private: 

 // Methods PRIVATE
 // 


 // Fields PRIVATE
 //
Handle_GeomFill_LocationLaw myLaw;
TColgp_Array1OfVec V;
TColgp_Array1OfVec DV;
TColgp_Array1OfVec D2V;
gp_Mat M;
gp_Mat DM;
gp_Mat D2M;


};





// other Inline functions and methods (like "C++: function call" methods)
//


#endif
