// File generated by CPPExt (Value)
//
//                     Copyright (C) 1991 - 2000 by  
//                      Matra Datavision SA.  All rights reserved.
//  
//                     Copyright (C) 2001 - 2004 by
//                     Open CASCADE SA.  All rights reserved.
// 
// This file is part of the Open CASCADE Technology software.
//
// This software may be distributed and/or modified under the terms and
// conditions of the Open CASCADE Public License as defined by Open CASCADE SA
// and appearing in the file LICENSE included in the packaging of this file.
//  
// This software is distributed on an "AS IS" basis, without warranty of any
// kind, and Open CASCADE SA hereby disclaims all such warranties,
// including without limitation, any warranties of merchantability, fitness
// for a particular purpose or non-infringement. Please see the License for
// the specific terms and conditions governing rights and limitations under the
// License.

#ifndef _GeomProjLib_HeaderFile
#define _GeomProjLib_HeaderFile

#ifndef _Handle_Geom2d_Curve_HeaderFile
#include <Handle_Geom2d_Curve.hxx>
#endif
#ifndef _Handle_Geom_Curve_HeaderFile
#include <Handle_Geom_Curve.hxx>
#endif
#ifndef _Standard_Real_HeaderFile
#include <Standard_Real.hxx>
#endif
#ifndef _Handle_Geom_Surface_HeaderFile
#include <Handle_Geom_Surface.hxx>
#endif
#ifndef _Handle_Geom_Plane_HeaderFile
#include <Handle_Geom_Plane.hxx>
#endif
#ifndef _Standard_Boolean_HeaderFile
#include <Standard_Boolean.hxx>
#endif
class Geom2d_Curve;
class Geom_Curve;
class Geom_Surface;
class Geom_Plane;
class gp_Dir;


#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif
#ifndef _Standard_Macro_HeaderFile
#include <Standard_Macro.hxx>
#endif

//! Projection of a curve on a surface. <br>
class GeomProjLib  {

public:

    void* operator new(size_t,void* anAddress) 
      {
        return anAddress;
      }
    void* operator new(size_t size) 
      { 
        return Standard::Allocate(size); 
      }
    void  operator delete(void *anAddress) 
      { 
        if (anAddress) Standard::Free((Standard_Address&)anAddress); 
      }
 // Methods PUBLIC
 // 


Standard_EXPORT static  Handle_Geom2d_Curve Curve2d(const Handle(Geom_Curve)& C,const Standard_Real First,const Standard_Real Last,const Handle(Geom_Surface)& S,const Standard_Real UFirst,const Standard_Real ULast,const Standard_Real VFirst,const Standard_Real VLast,Standard_Real& Tolerance) ;


Standard_EXPORT static  Handle_Geom2d_Curve Curve2d(const Handle(Geom_Curve)& C,const Standard_Real First,const Standard_Real Last,const Handle(Geom_Surface)& S,Standard_Real& Tolerance) ;


Standard_EXPORT static  Handle_Geom2d_Curve Curve2d(const Handle(Geom_Curve)& C,const Standard_Real First,const Standard_Real Last,const Handle(Geom_Surface)& S) ;


Standard_EXPORT static  Handle_Geom2d_Curve Curve2d(const Handle(Geom_Curve)& C,const Handle(Geom_Surface)& S) ;


Standard_EXPORT static  Handle_Geom2d_Curve Curve2d(const Handle(Geom_Curve)& C,const Handle(Geom_Surface)& S,const Standard_Real UDeb,const Standard_Real UFin,const Standard_Real VDeb,const Standard_Real VFin) ;


Standard_EXPORT static  Handle_Geom2d_Curve Curve2d(const Handle(Geom_Curve)& C,const Handle(Geom_Surface)& S,const Standard_Real UDeb,const Standard_Real UFin,const Standard_Real VDeb,const Standard_Real VFin,Standard_Real& Tolerance) ;


Standard_EXPORT static  Handle_Geom_Curve Project(const Handle(Geom_Curve)& C,const Handle(Geom_Surface)& S) ;


Standard_EXPORT static  Handle_Geom_Curve ProjectOnPlane(const Handle(Geom_Curve)& Curve,const Handle(Geom_Plane)& Plane,const gp_Dir& Dir,const Standard_Boolean KeepParametrization) ;





protected:

 // Methods PROTECTED
 // 


 // Fields PROTECTED
 //


private: 

 // Methods PRIVATE
 // 


 // Fields PRIVATE
 //


};





// other Inline functions and methods (like "C++: function call" methods)
//


#endif
