// File generated by CPPExt (Transient)
//
//
//                     Copyright (C) 1991 - 2000 by  
//                      Matra Datavision SA.  All rights reserved.
//  
//                     Copyright (C) 2001 - 2004 by
//                     Open CASCADE SA.  All rights reserved.
// 
// This file is part of the Open CASCADE Technology software.
//
// This software may be distributed and/or modified under the terms and
// conditions of the Open CASCADE Public License as defined by Open CASCADE SA
// and appearing in the file LICENSE included in the packaging of this file.
//  
// This software is distributed on an "AS IS" basis, without warranty of any
// kind, and Open CASCADE SA hereby disclaims all such warranties,
// including without limitation, any warranties of merchantability, fitness
// for a particular purpose or non-infringement. Please see the License for
// the specific terms and conditions governing rights and limitations under the
// License.

#ifndef _HLRAlgo_WiresBlock_HeaderFile
#define _HLRAlgo_WiresBlock_HeaderFile

#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif
#ifndef _Handle_HLRAlgo_WiresBlock_HeaderFile
#include <Handle_HLRAlgo_WiresBlock.hxx>
#endif

#ifndef _TColStd_Array1OfTransient_HeaderFile
#include <TColStd_Array1OfTransient.hxx>
#endif
#ifndef _Standard_Integer_HeaderFile
#include <Standard_Integer.hxx>
#endif
#ifndef _MMgt_TShared_HeaderFile
#include <MMgt_TShared.hxx>
#endif
#ifndef _Handle_HLRAlgo_EdgesBlock_HeaderFile
#include <Handle_HLRAlgo_EdgesBlock.hxx>
#endif
#ifndef _Standard_Address_HeaderFile
#include <Standard_Address.hxx>
#endif
class HLRAlgo_EdgesBlock;


//! A WiresBlock is a set of Blocks. It is used by the <br>
//!          DataStructure to structure the Edges. <br>
//! <br>
//!          A WiresBlock contains : <br>
//! <br>
//!          * An Array  of Blocks. <br>
class HLRAlgo_WiresBlock : public MMgt_TShared {

public:
 // Methods PUBLIC
 // 

//! Create a Block of Blocks. <br>
Standard_EXPORT HLRAlgo_WiresBlock(const Standard_Integer NbWires);


Standard_EXPORT   Standard_Integer NbWires() const;


Standard_EXPORT   void Set(const Standard_Integer I,const Handle(HLRAlgo_EdgesBlock)& W) ;


Standard_EXPORT   Handle_HLRAlgo_EdgesBlock& Wire(const Standard_Integer I) ;


Standard_EXPORT   void UpdateMinMax(const Standard_Address TotMinMax) ;

  Standard_Address MinMax() const;
//Standard_EXPORT ~HLRAlgo_WiresBlock();




 // Type management
 //
 Standard_EXPORT const Handle(Standard_Type)& DynamicType() const;
 //Standard_EXPORT Standard_Boolean	       IsKind(const Handle(Standard_Type)&) const;

protected:

 // Methods PROTECTED
 // 


 // Fields PROTECTED
 //


private: 

 // Methods PRIVATE
 // 


 // Fields PRIVATE
 //
TColStd_Array1OfTransient myWires;
Standard_Integer myMinMax[16];


};


#include <HLRAlgo_WiresBlock.lxx>



// other Inline functions and methods (like "C++: function call" methods)
//


#endif
