// File generated by CPPExt (Value)
//
//                     Copyright (C) 1991 - 2000 by  
//                      Matra Datavision SA.  All rights reserved.
//  
//                     Copyright (C) 2001 - 2004 by
//                     Open CASCADE SA.  All rights reserved.
// 
// This file is part of the Open CASCADE Technology software.
//
// This software may be distributed and/or modified under the terms and
// conditions of the Open CASCADE Public License as defined by Open CASCADE SA
// and appearing in the file LICENSE included in the packaging of this file.
//  
// This software is distributed on an "AS IS" basis, without warranty of any
// kind, and Open CASCADE SA hereby disclaims all such warranties,
// including without limitation, any warranties of merchantability, fitness
// for a particular purpose or non-infringement. Please see the License for
// the specific terms and conditions governing rights and limitations under the
// License.

#ifndef _HLRBRep_ShapeBounds_HeaderFile
#define _HLRBRep_ShapeBounds_HeaderFile

#ifndef _Handle_HLRTopoBRep_OutLiner_HeaderFile
#include <Handle_HLRTopoBRep_OutLiner.hxx>
#endif
#ifndef _Handle_MMgt_TShared_HeaderFile
#include <Handle_MMgt_TShared.hxx>
#endif
#ifndef _Standard_Integer_HeaderFile
#include <Standard_Integer.hxx>
#endif
#ifndef _Standard_Address_HeaderFile
#include <Standard_Address.hxx>
#endif
class HLRTopoBRep_OutLiner;
class MMgt_TShared;


#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif
#ifndef _Standard_Macro_HeaderFile
#include <Standard_Macro.hxx>
#endif

//! Contains  a Shape and the  bounds of its vertices, <br>
//!          edges and faces in the DataStructure. <br>
class HLRBRep_ShapeBounds  {

public:

    void* operator new(size_t,void* anAddress) 
      {
        return anAddress;
      }
    void* operator new(size_t size) 
      { 
        return Standard::Allocate(size); 
      }
    void  operator delete(void *anAddress) 
      { 
        if (anAddress) Standard::Free((Standard_Address&)anAddress); 
      }
 // Methods PUBLIC
 // 

HLRBRep_ShapeBounds();


Standard_EXPORT HLRBRep_ShapeBounds(const Handle(HLRTopoBRep_OutLiner)& S,const Handle(MMgt_TShared)& SData,const Standard_Integer nbIso,const Standard_Integer V1,const Standard_Integer V2,const Standard_Integer E1,const Standard_Integer E2,const Standard_Integer F1,const Standard_Integer F2);


Standard_EXPORT HLRBRep_ShapeBounds(const Handle(HLRTopoBRep_OutLiner)& S,const Standard_Integer nbIso,const Standard_Integer V1,const Standard_Integer V2,const Standard_Integer E1,const Standard_Integer E2,const Standard_Integer F1,const Standard_Integer F2);


Standard_EXPORT   void Translate(const Standard_Integer NV,const Standard_Integer NE,const Standard_Integer NF) ;

  void Shape(const Handle(HLRTopoBRep_OutLiner)& S) ;

 const Handle_HLRTopoBRep_OutLiner& Shape() const;

  void ShapeData(const Handle(MMgt_TShared)& SD) ;

 const Handle_MMgt_TShared& ShapeData() const;

  void NbOfIso(const Standard_Integer nbIso) ;

  Standard_Integer NbOfIso() const;


Standard_EXPORT   void Sizes(Standard_Integer& NV,Standard_Integer& NE,Standard_Integer& NF) const;


Standard_EXPORT   void Bounds(Standard_Integer& V1,Standard_Integer& V2,Standard_Integer& E1,Standard_Integer& E2,Standard_Integer& F1,Standard_Integer& F2) const;


Standard_EXPORT   void UpdateMinMax(const Standard_Address TotMinMax) ;

  Standard_Address MinMax() const;





protected:

 // Methods PROTECTED
 // 


 // Fields PROTECTED
 //


private: 

 // Methods PRIVATE
 // 


 // Fields PRIVATE
 //
Handle_HLRTopoBRep_OutLiner myShape;
Handle_MMgt_TShared myShapeData;
Standard_Integer myNbIso;
Standard_Integer myVertStart;
Standard_Integer myVertEnd;
Standard_Integer myEdgeStart;
Standard_Integer myEdgeEnd;
Standard_Integer myFaceStart;
Standard_Integer myFaceEnd;
Standard_Integer myMinMax[16];


};


#include <HLRBRep_ShapeBounds.lxx>



// other Inline functions and methods (like "C++: function call" methods)
//


#endif
