// File generated by CPPExt (Value)
//
//                     Copyright (C) 1991 - 2000 by  
//                      Matra Datavision SA.  All rights reserved.
//  
//                     Copyright (C) 2001 - 2004 by
//                     Open CASCADE SA.  All rights reserved.
// 
// This file is part of the Open CASCADE Technology software.
//
// This software may be distributed and/or modified under the terms and
// conditions of the Open CASCADE Public License as defined by Open CASCADE SA
// and appearing in the file LICENSE included in the packaging of this file.
//  
// This software is distributed on an "AS IS" basis, without warranty of any
// kind, and Open CASCADE SA hereby disclaims all such warranties,
// including without limitation, any warranties of merchantability, fitness
// for a particular purpose or non-infringement. Please see the License for
// the specific terms and conditions governing rights and limitations under the
// License.

#ifndef _HLRBRep_SurfaceTool_HeaderFile
#define _HLRBRep_SurfaceTool_HeaderFile

#ifndef _Standard_Real_HeaderFile
#include <Standard_Real.hxx>
#endif
#ifndef _Standard_Address_HeaderFile
#include <Standard_Address.hxx>
#endif
#ifndef _Standard_Integer_HeaderFile
#include <Standard_Integer.hxx>
#endif
#ifndef _GeomAbs_Shape_HeaderFile
#include <GeomAbs_Shape.hxx>
#endif
#ifndef _Handle_Adaptor3d_HSurface_HeaderFile
#include <Handle_Adaptor3d_HSurface.hxx>
#endif
#ifndef _Standard_Boolean_HeaderFile
#include <Standard_Boolean.hxx>
#endif
#ifndef _gp_Pnt_HeaderFile
#include <gp_Pnt.hxx>
#endif
#ifndef _gp_Vec_HeaderFile
#include <gp_Vec.hxx>
#endif
#ifndef _GeomAbs_SurfaceType_HeaderFile
#include <GeomAbs_SurfaceType.hxx>
#endif
#ifndef _gp_Pln_HeaderFile
#include <gp_Pln.hxx>
#endif
#ifndef _gp_Cylinder_HeaderFile
#include <gp_Cylinder.hxx>
#endif
#ifndef _gp_Cone_HeaderFile
#include <gp_Cone.hxx>
#endif
#ifndef _gp_Torus_HeaderFile
#include <gp_Torus.hxx>
#endif
#ifndef _gp_Sphere_HeaderFile
#include <gp_Sphere.hxx>
#endif
#ifndef _Handle_Geom_BezierSurface_HeaderFile
#include <Handle_Geom_BezierSurface.hxx>
#endif
#ifndef _Handle_Geom_BSplineSurface_HeaderFile
#include <Handle_Geom_BSplineSurface.hxx>
#endif
#ifndef _gp_Ax1_HeaderFile
#include <gp_Ax1.hxx>
#endif
#ifndef _gp_Dir_HeaderFile
#include <gp_Dir.hxx>
#endif
#ifndef _Handle_Adaptor3d_HCurve_HeaderFile
#include <Handle_Adaptor3d_HCurve.hxx>
#endif
class Standard_NoSuchObject;
class Standard_OutOfRange;
class TColStd_Array1OfReal;
class Adaptor3d_HSurface;
class gp_Pnt;
class gp_Vec;
class Geom_BezierSurface;
class Geom_BSplineSurface;
class Adaptor3d_HCurve;


#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif
#ifndef _Standard_Macro_HeaderFile
#include <Standard_Macro.hxx>
#endif


class HLRBRep_SurfaceTool  {

public:

    void* operator new(size_t,void* anAddress) 
      {
        return anAddress;
      }
    void* operator new(size_t size) 
      { 
        return Standard::Allocate(size); 
      }
    void  operator delete(void *anAddress) 
      { 
        if (anAddress) Standard::Free((Standard_Address&)anAddress); 
      }
 // Methods PUBLIC
 // 

static  Standard_Real FirstUParameter(const Standard_Address S) ;

static  Standard_Real FirstVParameter(const Standard_Address S) ;

static  Standard_Real LastUParameter(const Standard_Address S) ;

static  Standard_Real LastVParameter(const Standard_Address S) ;

static  Standard_Integer NbUIntervals(const Standard_Address S,const GeomAbs_Shape Sh) ;

static  Standard_Integer NbVIntervals(const Standard_Address S,const GeomAbs_Shape Sh) ;

static  void UIntervals(const Standard_Address S,TColStd_Array1OfReal& T,const GeomAbs_Shape Sh) ;

static  void VIntervals(const Standard_Address S,TColStd_Array1OfReal& T,const GeomAbs_Shape Sh) ;
//! If <First> >= <Last> <br>
static  Handle_Adaptor3d_HSurface UTrim(const Standard_Address S,const Standard_Real First,const Standard_Real Last,const Standard_Real Tol) ;
//! If <First> >= <Last> <br>
static  Handle_Adaptor3d_HSurface VTrim(const Standard_Address S,const Standard_Real First,const Standard_Real Last,const Standard_Real Tol) ;

static  Standard_Boolean IsUClosed(const Standard_Address S) ;

static  Standard_Boolean IsVClosed(const Standard_Address S) ;

static  Standard_Boolean IsUPeriodic(const Standard_Address S) ;

static  Standard_Real UPeriod(const Standard_Address S) ;

static  Standard_Boolean IsVPeriodic(const Standard_Address S) ;

static  Standard_Real VPeriod(const Standard_Address S) ;

static  gp_Pnt Value(const Standard_Address S,const Standard_Real u,const Standard_Real v) ;

static  void D0(const Standard_Address S,const Standard_Real u,const Standard_Real v,gp_Pnt& P) ;

static  void D1(const Standard_Address S,const Standard_Real u,const Standard_Real v,gp_Pnt& P,gp_Vec& D1u,gp_Vec& D1v) ;

static  void D2(const Standard_Address S,const Standard_Real u,const Standard_Real v,gp_Pnt& P,gp_Vec& D1U,gp_Vec& D1V,gp_Vec& D2U,gp_Vec& D2V,gp_Vec& D2UV) ;

static  void D3(const Standard_Address S,const Standard_Real u,const Standard_Real v,gp_Pnt& P,gp_Vec& D1U,gp_Vec& D1V,gp_Vec& D2U,gp_Vec& D2V,gp_Vec& D2UV,gp_Vec& D3U,gp_Vec& D3V,gp_Vec& D3UUV,gp_Vec& D3UVV) ;

static  gp_Vec DN(const Standard_Address S,const Standard_Real u,const Standard_Real v,const Standard_Integer Nu,const Standard_Integer Nv) ;

static  Standard_Real UResolution(const Standard_Address S,const Standard_Real R3d) ;

static  Standard_Real VResolution(const Standard_Address S,const Standard_Real R3d) ;

static  GeomAbs_SurfaceType GetType(const Standard_Address S) ;

static  gp_Pln Plane(const Standard_Address S) ;

static  gp_Cylinder Cylinder(const Standard_Address S) ;

static  gp_Cone Cone(const Standard_Address S) ;

static  gp_Torus Torus(const Standard_Address S) ;

static  gp_Sphere Sphere(const Standard_Address S) ;

static  Handle_Geom_BezierSurface Bezier(const Standard_Address S) ;

static  Handle_Geom_BSplineSurface BSpline(const Standard_Address S) ;

static  gp_Ax1 AxeOfRevolution(const Standard_Address S) ;

static  gp_Dir Direction(const Standard_Address S) ;

static  Handle_Adaptor3d_HCurve BasisCurve(const Standard_Address S) ;

static  Handle_Adaptor3d_HSurface BasisSurface(const Standard_Address S) ;

static  Standard_Real OffsetValue(const Standard_Address S) ;


Standard_EXPORT static  Standard_Integer NbSamplesU(const Standard_Address S) ;


Standard_EXPORT static  Standard_Integer NbSamplesV(const Standard_Address S) ;


Standard_EXPORT static  Standard_Integer NbSamplesU(const Standard_Address S,const Standard_Real u1,const Standard_Real u2) ;


Standard_EXPORT static  Standard_Integer NbSamplesV(const Standard_Address S,const Standard_Real v1,const Standard_Real v2) ;





protected:

 // Methods PROTECTED
 // 


 // Fields PROTECTED
 //


private: 

 // Methods PRIVATE
 // 


 // Fields PRIVATE
 //


};


#include <HLRBRep_SurfaceTool.lxx>



// other Inline functions and methods (like "C++: function call" methods)
//


#endif
