// File generated by CPPExt (Transient)
//
//
//                     Copyright (C) 1991 - 2000 by  
//                      Matra Datavision SA.  All rights reserved.
//  
//                     Copyright (C) 2001 - 2004 by
//                     Open CASCADE SA.  All rights reserved.
// 
// This file is part of the Open CASCADE Technology software.
//
// This software may be distributed and/or modified under the terms and
// conditions of the Open CASCADE Public License as defined by Open CASCADE SA
// and appearing in the file LICENSE included in the packaging of this file.
//  
// This software is distributed on an "AS IS" basis, without warranty of any
// kind, and Open CASCADE SA hereby disclaims all such warranties,
// including without limitation, any warranties of merchantability, fitness
// for a particular purpose or non-infringement. Please see the License for
// the specific terms and conditions governing rights and limitations under the
// License.

#ifndef _IGESAppli_RegionRestriction_HeaderFile
#define _IGESAppli_RegionRestriction_HeaderFile

#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif
#ifndef _Handle_IGESAppli_RegionRestriction_HeaderFile
#include <Handle_IGESAppli_RegionRestriction.hxx>
#endif

#ifndef _Standard_Integer_HeaderFile
#include <Standard_Integer.hxx>
#endif
#ifndef _IGESData_IGESEntity_HeaderFile
#include <IGESData_IGESEntity.hxx>
#endif


//! defines RegionRestriction, Type <406> Form <2> <br>
//!          in package IGESAppli <br>
//!          Defines regions to set an application's restriction <br>
//!          over a region. <br>
class IGESAppli_RegionRestriction : public IGESData_IGESEntity {

public:
 // Methods PUBLIC
 // 


Standard_EXPORT IGESAppli_RegionRestriction();

//! This method is used to set the fields of the class <br>
//!           RegionRestriction <br>
//!       - nbPropVal  : Number of property values, always = 3 <br>
//!       - aViasRest  : Electrical Vias restriction <br>
//!       - aCompoRest : Electrical components restriction <br>
//!       - aCktRest   : Electrical circuitry restriction <br>
Standard_EXPORT   void Init(const Standard_Integer nbPropVal,const Standard_Integer aViasRest,const Standard_Integer aCompoRest,const Standard_Integer aCktRest) ;

//! is always 3 <br>
Standard_EXPORT   Standard_Integer NbPropertyValues() const;

//! returns the Electrical vias restriction <br>
//! is 0, 1 or 2 <br>
Standard_EXPORT   Standard_Integer ElectricalViasRestriction() const;

//! returns the Electrical components restriction <br>
//! is 0, 1 or 2 <br>
Standard_EXPORT   Standard_Integer ElectricalComponentRestriction() const;

//! returns the Electrical circuitry restriction <br>
//! is 0, 1 or 2 <br>
Standard_EXPORT   Standard_Integer ElectricalCktRestriction() const;
//Standard_EXPORT ~IGESAppli_RegionRestriction();




 // Type management
 //
 Standard_EXPORT const Handle(Standard_Type)& DynamicType() const;
 //Standard_EXPORT Standard_Boolean	       IsKind(const Handle(Standard_Type)&) const;

protected:

 // Methods PROTECTED
 // 


 // Fields PROTECTED
 //


private: 

 // Methods PRIVATE
 // 


 // Fields PRIVATE
 //
Standard_Integer theNbPropertyValues;
Standard_Integer theElectViasRestrict;
Standard_Integer theElectCompRestrict;
Standard_Integer theElectCktRestrict;


};





// other Inline functions and methods (like "C++: function call" methods)
//


#endif
