// File generated by CPPExt (Transient)
//
//
//                     Copyright (C) 1991 - 2000 by  
//                      Matra Datavision SA.  All rights reserved.
//  
//                     Copyright (C) 2001 - 2004 by
//                     Open CASCADE SA.  All rights reserved.
// 
// This file is part of the Open CASCADE Technology software.
//
// This software may be distributed and/or modified under the terms and
// conditions of the Open CASCADE Public License as defined by Open CASCADE SA
// and appearing in the file LICENSE included in the packaging of this file.
//  
// This software is distributed on an "AS IS" basis, without warranty of any
// kind, and Open CASCADE SA hereby disclaims all such warranties,
// including without limitation, any warranties of merchantability, fitness
// for a particular purpose or non-infringement. Please see the License for
// the specific terms and conditions governing rights and limitations under the
// License.

#ifndef _IGESBasic_ExternalRefFileIndex_HeaderFile
#define _IGESBasic_ExternalRefFileIndex_HeaderFile

#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif
#ifndef _Handle_IGESBasic_ExternalRefFileIndex_HeaderFile
#include <Handle_IGESBasic_ExternalRefFileIndex.hxx>
#endif

#ifndef _Handle_Interface_HArray1OfHAsciiString_HeaderFile
#include <Handle_Interface_HArray1OfHAsciiString.hxx>
#endif
#ifndef _Handle_IGESData_HArray1OfIGESEntity_HeaderFile
#include <Handle_IGESData_HArray1OfIGESEntity.hxx>
#endif
#ifndef _IGESData_IGESEntity_HeaderFile
#include <IGESData_IGESEntity.hxx>
#endif
#ifndef _Standard_Integer_HeaderFile
#include <Standard_Integer.hxx>
#endif
#ifndef _Handle_TCollection_HAsciiString_HeaderFile
#include <Handle_TCollection_HAsciiString.hxx>
#endif
#ifndef _Handle_IGESData_IGESEntity_HeaderFile
#include <Handle_IGESData_IGESEntity.hxx>
#endif
class Interface_HArray1OfHAsciiString;
class IGESData_HArray1OfIGESEntity;
class Standard_DimensionMismatch;
class Standard_OutOfRange;
class TCollection_HAsciiString;
class IGESData_IGESEntity;


//! defines ExternalRefFileIndex, Type <402> Form <12> <br>
//!          in package IGESBasic <br>
//!          Contains a list of the symbolic names used by the <br>
//!          referencing files and the DE pointers to the <br>
//!          corresponding definitions within the referenced file <br>
class IGESBasic_ExternalRefFileIndex : public IGESData_IGESEntity {

public:
 // Methods PUBLIC
 // 


Standard_EXPORT IGESBasic_ExternalRefFileIndex();

//! This method is used to set the fields of the class <br>
//!           ExternalRefFileIndex <br>
//!       - aNameArray  : External Reference Entity symbolic names <br>
//!       - allEntities : External Reference Entities <br>
//! raises exception if array lengths are not equal <br>
//! if size of aNameArray is not equal to size of allEntities <br>
Standard_EXPORT   void Init(const Handle(Interface_HArray1OfHAsciiString)& aNameArray,const Handle(IGESData_HArray1OfIGESEntity)& allEntities) ;

//! returns number of index entries <br>
Standard_EXPORT   Standard_Integer NbEntries() const;

//! returns the External Reference Entity symbolic name <br>
//! raises exception if Index <= 0 or Index > NbEntries() <br>
Standard_EXPORT   Handle_TCollection_HAsciiString Name(const Standard_Integer Index) const;

//! returns the internal entity <br>
//! raises exception if Index <= 0 or Index > NbEntries() <br>
Standard_EXPORT   Handle_IGESData_IGESEntity Entity(const Standard_Integer Index) const;
//Standard_EXPORT ~IGESBasic_ExternalRefFileIndex();




 // Type management
 //
 Standard_EXPORT const Handle(Standard_Type)& DynamicType() const;
 //Standard_EXPORT Standard_Boolean	       IsKind(const Handle(Standard_Type)&) const;

protected:

 // Methods PROTECTED
 // 


 // Fields PROTECTED
 //


private: 

 // Methods PRIVATE
 // 


 // Fields PRIVATE
 //
Handle_Interface_HArray1OfHAsciiString theNames;
Handle_IGESData_HArray1OfIGESEntity theEntities;


};





// other Inline functions and methods (like "C++: function call" methods)
//


#endif
