// File generated by CPPExt (Transient)
//
//
//                     Copyright (C) 1991 - 2000 by  
//                      Matra Datavision SA.  All rights reserved.
//  
//                     Copyright (C) 2001 - 2004 by
//                     Open CASCADE SA.  All rights reserved.
// 
// This file is part of the Open CASCADE Technology software.
//
// This software may be distributed and/or modified under the terms and
// conditions of the Open CASCADE Public License as defined by Open CASCADE SA
// and appearing in the file LICENSE included in the packaging of this file.
//  
// This software is distributed on an "AS IS" basis, without warranty of any
// kind, and Open CASCADE SA hereby disclaims all such warranties,
// including without limitation, any warranties of merchantability, fitness
// for a particular purpose or non-infringement. Please see the License for
// the specific terms and conditions governing rights and limitations under the
// License.

#ifndef _IGESBasic_SingularSubfigure_HeaderFile
#define _IGESBasic_SingularSubfigure_HeaderFile

#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif
#ifndef _Handle_IGESBasic_SingularSubfigure_HeaderFile
#include <Handle_IGESBasic_SingularSubfigure.hxx>
#endif

#ifndef _Handle_IGESBasic_SubfigureDef_HeaderFile
#include <Handle_IGESBasic_SubfigureDef.hxx>
#endif
#ifndef _gp_XYZ_HeaderFile
#include <gp_XYZ.hxx>
#endif
#ifndef _Standard_Real_HeaderFile
#include <Standard_Real.hxx>
#endif
#ifndef _Standard_Boolean_HeaderFile
#include <Standard_Boolean.hxx>
#endif
#ifndef _IGESData_IGESEntity_HeaderFile
#include <IGESData_IGESEntity.hxx>
#endif
class IGESBasic_SubfigureDef;
class gp_XYZ;


//! defines SingularSubfigure, Type <408> Form <0> <br>
//!          in package IGESBasic <br>
//!          Defines the occurrence of a single instance of the <br>
//!          defined Subfigure. <br>
class IGESBasic_SingularSubfigure : public IGESData_IGESEntity {

public:
 // Methods PUBLIC
 // 


Standard_EXPORT IGESBasic_SingularSubfigure();

//! This method is used to set the fields of the class <br>
//!           SingularSubfigure <br>
//!       - aSubfigureDef : the Subfigure Definition entity <br>
//!       - aTranslation  : used to store the X,Y,Z coord <br>
//!       - hasScale      : Indicates the presence of scale factor <br>
//!       - aScale        : Used to store the scale factor <br>
Standard_EXPORT   void Init(const Handle(IGESBasic_SubfigureDef)& aSubfigureDef,const gp_XYZ& aTranslation,const Standard_Boolean hasScale,const Standard_Real aScale) ;

//! returns the subfigure definition entity <br>
Standard_EXPORT   Handle_IGESBasic_SubfigureDef Subfigure() const;

//! returns the X, Y, Z coordinates <br>
Standard_EXPORT   gp_XYZ Translation() const;

//! returns the scale factor <br>
//! if hasScaleFactor is False, returns 1.0 (default) <br>
Standard_EXPORT   Standard_Real ScaleFactor() const;

//! returns a boolean indicating whether scale factor <br>
//! is present or not <br>
Standard_EXPORT   Standard_Boolean HasScaleFactor() const;

//! returns the Translation after transformation <br>
Standard_EXPORT   gp_XYZ TransformedTranslation() const;
//Standard_EXPORT ~IGESBasic_SingularSubfigure();




 // Type management
 //
 Standard_EXPORT const Handle(Standard_Type)& DynamicType() const;
 //Standard_EXPORT Standard_Boolean	       IsKind(const Handle(Standard_Type)&) const;

protected:

 // Methods PROTECTED
 // 


 // Fields PROTECTED
 //


private: 

 // Methods PRIVATE
 // 


 // Fields PRIVATE
 //
Handle_IGESBasic_SubfigureDef theSubfigureDef;
gp_XYZ theTranslation;
Standard_Real theScaleFactor;
Standard_Boolean hasScaleFactor;


};





// other Inline functions and methods (like "C++: function call" methods)
//


#endif
