// File generated by CPPExt (Enum)
//
//                     Copyright (C) 1991 - 2000 by  
//                      Matra Datavision SA.  All rights reserved.
//  
//                     Copyright (C) 2001 - 2004 by
//                     Open CASCADE SA.  All rights reserved.
// 
// This file is part of the Open CASCADE Technology software.
//
// This software may be distributed and/or modified under the terms and
// conditions of the Open CASCADE Public License as defined by Open CASCADE SA
// and appearing in the file LICENSE included in the packaging of this file.
//  
// This software is distributed on an "AS IS" basis, without warranty of any
// kind, and Open CASCADE SA hereby disclaims all such warranties,
// including without limitation, any warranties of merchantability, fitness
// for a particular purpose or non-infringement. Please see the License for
// the specific terms and conditions governing rights and limitations under the
// License.

#ifndef _IGESData_DefList_HeaderFile
#define _IGESData_DefList_HeaderFile

//!  Some fields of an IGES entity may be <br>
//! - Undefined <br>
//! - Defined as a positive integer <br>
//! - Defined as a reference to a specialized entity. <br>
//!  A typical example of this kind of variation is color. <br>
//! This enumeration allows you to identify which of the above is the case. <br>
//! The semantics of the terms are as follows: <br>
//! - DefVoid indicates that the item contained in the field is undefined <br>
//! - DefValue indicates that the item is defined as an immediate <br>
//!   positive integer value (i.e. not a pointer) <br>
//! - DefReference indicates that the item is defined as an entity <br>
//! - DefAny indicates the item could not be determined <br>
//! - ErrorVal indicates that the item is defined as an integer <br>
//!   but its value is incorrect (it could be out of range, for example) <br>
//! - ErrorRef indicates that the item is defined as an entity but <br>
//!    is not of the required type. <br>
enum IGESData_DefList { 
 IGESData_DefNone,
IGESData_DefOne,
IGESData_DefSeveral,
IGESData_ErrorOne,
IGESData_ErrorSeveral
};


#ifndef _Standard_PrimitiveTypes_HeaderFile
#include <Standard_PrimitiveTypes.hxx>
#endif

#endif
