// File generated by CPPExt (Enum)
//
//                     Copyright (C) 1991 - 2000 by  
//                      Matra Datavision SA.  All rights reserved.
//  
//                     Copyright (C) 2001 - 2004 by
//                     Open CASCADE SA.  All rights reserved.
// 
// This file is part of the Open CASCADE Technology software.
//
// This software may be distributed and/or modified under the terms and
// conditions of the Open CASCADE Public License as defined by Open CASCADE SA
// and appearing in the file LICENSE included in the packaging of this file.
//  
// This software is distributed on an "AS IS" basis, without warranty of any
// kind, and Open CASCADE SA hereby disclaims all such warranties,
// including without limitation, any warranties of merchantability, fitness
// for a particular purpose or non-infringement. Please see the License for
// the specific terms and conditions governing rights and limitations under the
// License.

#ifndef _IGESData_ReadStage_HeaderFile
#define _IGESData_ReadStage_HeaderFile

//! Some fields of an IGES entity may be <br>
//! - Undefined <br>
//! - Defined as a single item <br>
//! - Defined as a list of items. <br>
//!   A typical example, which presents this kind of variation, <br>
//! is a level number. <br>
//! This enumeration allows you to identify which of the above is the case. <br>
//! The semantics of the terms is as follows: <br>
//! - DefNone indicates that the list is empty (there is not <br>
//!   even a single item). <br>
//! - DefOne indicates that the list contains a single item. <br>
//! - DefSeveral indicates that the list contains several items. <br>
//! - ErrorOne indicates that the list contains one item, but <br>
//!   that this item is incorrect <br>
//! - ErrorSeveral indicates that the list contains several <br>
//!   items, but that at least one of them is incorrect. <br>
enum IGESData_ReadStage { 
 IGESData_ReadDir,
IGESData_ReadOwn,
IGESData_ReadAssocs,
IGESData_ReadProps,
IGESData_ReadEnd
};


#ifndef _Standard_PrimitiveTypes_HeaderFile
#include <Standard_PrimitiveTypes.hxx>
#endif

#endif
