// File generated by CPPExt (Transient)
//
//
//                     Copyright (C) 1991 - 2000 by  
//                      Matra Datavision SA.  All rights reserved.
//  
//                     Copyright (C) 2001 - 2004 by
//                     Open CASCADE SA.  All rights reserved.
// 
// This file is part of the Open CASCADE Technology software.
//
// This software may be distributed and/or modified under the terms and
// conditions of the Open CASCADE Public License as defined by Open CASCADE SA
// and appearing in the file LICENSE included in the packaging of this file.
//  
// This software is distributed on an "AS IS" basis, without warranty of any
// kind, and Open CASCADE SA hereby disclaims all such warranties,
// including without limitation, any warranties of merchantability, fitness
// for a particular purpose or non-infringement. Please see the License for
// the specific terms and conditions governing rights and limitations under the
// License.

#ifndef _IGESDefs_Protocol_HeaderFile
#define _IGESDefs_Protocol_HeaderFile

#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif
#ifndef _Handle_IGESDefs_Protocol_HeaderFile
#include <Handle_IGESDefs_Protocol.hxx>
#endif

#ifndef _IGESData_Protocol_HeaderFile
#include <IGESData_Protocol.hxx>
#endif
#ifndef _Standard_Integer_HeaderFile
#include <Standard_Integer.hxx>
#endif
#ifndef _Handle_Interface_Protocol_HeaderFile
#include <Handle_Interface_Protocol.hxx>
#endif
#ifndef _Handle_Standard_Type_HeaderFile
#include <Handle_Standard_Type.hxx>
#endif
class Interface_Protocol;
class Standard_Type;


//! Description of Protocol for IGESDefs <br>
class IGESDefs_Protocol : public IGESData_Protocol {

public:
 // Methods PUBLIC
 // 


Standard_EXPORT IGESDefs_Protocol();

//! Gives the count of Resource Protocol. Here, one <br>
//!           (Protocol from IGESGraph) <br>
Standard_EXPORT virtual  Standard_Integer NbResources() const;

//! Returns a Resource, given a rank. <br>
Standard_EXPORT virtual  Handle_Interface_Protocol Resource(const Standard_Integer num) const;

//! Returns a Case Number, specific of each recognized Type <br>
//!           This Case Number is then used in Libraries : the various <br>
//!           Modules attached to this class of Protocol must use them <br>
//!           in accordance (for a given value of TypeNumber, they must <br>
//!           consider the same Type as the Protocol defines) <br>
Standard_EXPORT virtual  Standard_Integer TypeNumber(const Handle(Standard_Type)& atype) const;
//Standard_EXPORT ~IGESDefs_Protocol();




 // Type management
 //
 Standard_EXPORT const Handle(Standard_Type)& DynamicType() const;
 //Standard_EXPORT Standard_Boolean	       IsKind(const Handle(Standard_Type)&) const;

protected:

 // Methods PROTECTED
 // 


 // Fields PROTECTED
 //


private: 

 // Methods PRIVATE
 // 


 // Fields PRIVATE
 //


};





// other Inline functions and methods (like "C++: function call" methods)
//


#endif
