// File generated by CPPExt (Transient)
//
//
//                     Copyright (C) 1991 - 2000 by  
//                      Matra Datavision SA.  All rights reserved.
//  
//                     Copyright (C) 2001 - 2004 by
//                     Open CASCADE SA.  All rights reserved.
// 
// This file is part of the Open CASCADE Technology software.
//
// This software may be distributed and/or modified under the terms and
// conditions of the Open CASCADE Public License as defined by Open CASCADE SA
// and appearing in the file LICENSE included in the packaging of this file.
//  
// This software is distributed on an "AS IS" basis, without warranty of any
// kind, and Open CASCADE SA hereby disclaims all such warranties,
// including without limitation, any warranties of merchantability, fitness
// for a particular purpose or non-infringement. Please see the License for
// the specific terms and conditions governing rights and limitations under the
// License.

#ifndef _IGESGeom_Direction_HeaderFile
#define _IGESGeom_Direction_HeaderFile

#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif
#ifndef _Handle_IGESGeom_Direction_HeaderFile
#include <Handle_IGESGeom_Direction.hxx>
#endif

#ifndef _gp_XYZ_HeaderFile
#include <gp_XYZ.hxx>
#endif
#ifndef _IGESData_IGESEntity_HeaderFile
#include <IGESData_IGESEntity.hxx>
#endif
class gp_XYZ;
class gp_Vec;


//! defines IGESDirection, Type <123> Form <0> <br>
//!          in package IGESGeom <br>
//!          A direction entity is a non-zero vector in Euclidean 3-space <br>
//!          that is defined by its three components (direction ratios) <br>
//!          with respect to the coordinate axes. If x, y, z are the <br>
//!          direction ratios then (x^2 + y^2 + z^2) > 0 <br>
class IGESGeom_Direction : public IGESData_IGESEntity {

public:
 // Methods PUBLIC
 // 


Standard_EXPORT IGESGeom_Direction();

//! This method is used to set the fields of the class <br>
//!           Direction <br>
//!       - aDirection : Direction ratios, Z is 0 by default <br>
Standard_EXPORT   void Init(const gp_XYZ& aDirection) ;


Standard_EXPORT   gp_Vec Value() const;

//! returns the Direction value after applying Transformation matrix <br>
Standard_EXPORT   gp_Vec TransformedValue() const;
//Standard_EXPORT ~IGESGeom_Direction();




 // Type management
 //
 Standard_EXPORT const Handle(Standard_Type)& DynamicType() const;
 //Standard_EXPORT Standard_Boolean	       IsKind(const Handle(Standard_Type)&) const;

protected:

 // Methods PROTECTED
 // 


 // Fields PROTECTED
 //


private: 

 // Methods PRIVATE
 // 


 // Fields PRIVATE
 //
gp_XYZ theDirection;


};





// other Inline functions and methods (like "C++: function call" methods)
//


#endif
