// File generated by CPPExt (Transient)
//
//
//                     Copyright (C) 1991 - 2000 by  
//                      Matra Datavision SA.  All rights reserved.
//  
//                     Copyright (C) 2001 - 2004 by
//                     Open CASCADE SA.  All rights reserved.
// 
// This file is part of the Open CASCADE Technology software.
//
// This software may be distributed and/or modified under the terms and
// conditions of the Open CASCADE Public License as defined by Open CASCADE SA
// and appearing in the file LICENSE included in the packaging of this file.
//  
// This software is distributed on an "AS IS" basis, without warranty of any
// kind, and Open CASCADE SA hereby disclaims all such warranties,
// including without limitation, any warranties of merchantability, fitness
// for a particular purpose or non-infringement. Please see the License for
// the specific terms and conditions governing rights and limitations under the
// License.

#ifndef _IGESGeom_Point_HeaderFile
#define _IGESGeom_Point_HeaderFile

#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif
#ifndef _Handle_IGESGeom_Point_HeaderFile
#include <Handle_IGESGeom_Point.hxx>
#endif

#ifndef _gp_XYZ_HeaderFile
#include <gp_XYZ.hxx>
#endif
#ifndef _Handle_IGESBasic_SubfigureDef_HeaderFile
#include <Handle_IGESBasic_SubfigureDef.hxx>
#endif
#ifndef _IGESData_IGESEntity_HeaderFile
#include <IGESData_IGESEntity.hxx>
#endif
#ifndef _Standard_Boolean_HeaderFile
#include <Standard_Boolean.hxx>
#endif
class IGESBasic_SubfigureDef;
class gp_XYZ;
class gp_Pnt;


//! defines IGESPoint, Type <116> Form <0> <br>
//!          in package IGESGeom <br>
class IGESGeom_Point : public IGESData_IGESEntity {

public:
 // Methods PUBLIC
 // 


Standard_EXPORT IGESGeom_Point();

//! This method is used to set the fields of the class Point <br>
//!       - aPoint  : Coordinates of point <br>
//!       - aSymbol : SubfigureDefinition entity specifying the <br>
//!                   display symbol if there exists one, or zero <br>
Standard_EXPORT   void Init(const gp_XYZ& aPoint,const Handle(IGESBasic_SubfigureDef)& aSymbol) ;

//! returns co-ordinates of the point <br>
Standard_EXPORT   gp_Pnt Value() const;

//! returns co-ordinates of the point after applying Transf. Matrix <br>
Standard_EXPORT   gp_Pnt TransformedValue() const;

//! returns True if symbol exists <br>
Standard_EXPORT   Standard_Boolean HasDisplaySymbol() const;

//! returns display symbol entity if it exists <br>
Standard_EXPORT   Handle_IGESBasic_SubfigureDef DisplaySymbol() const;
//Standard_EXPORT ~IGESGeom_Point();




 // Type management
 //
 Standard_EXPORT const Handle(Standard_Type)& DynamicType() const;
 //Standard_EXPORT Standard_Boolean	       IsKind(const Handle(Standard_Type)&) const;

protected:

 // Methods PROTECTED
 // 


 // Fields PROTECTED
 //


private: 

 // Methods PRIVATE
 // 


 // Fields PRIVATE
 //
gp_XYZ thePoint;
Handle_IGESBasic_SubfigureDef theSymbol;


};





// other Inline functions and methods (like "C++: function call" methods)
//


#endif
