// File generated by CPPExt (Transient)
//
//
//                     Copyright (C) 1991 - 2000 by  
//                      Matra Datavision SA.  All rights reserved.
//  
//                     Copyright (C) 2001 - 2004 by
//                     Open CASCADE SA.  All rights reserved.
// 
// This file is part of the Open CASCADE Technology software.
//
// This software may be distributed and/or modified under the terms and
// conditions of the Open CASCADE Public License as defined by Open CASCADE SA
// and appearing in the file LICENSE included in the packaging of this file.
//  
// This software is distributed on an "AS IS" basis, without warranty of any
// kind, and Open CASCADE SA hereby disclaims all such warranties,
// including without limitation, any warranties of merchantability, fitness
// for a particular purpose or non-infringement. Please see the License for
// the specific terms and conditions governing rights and limitations under the
// License.

#ifndef _IGESGraph_Color_HeaderFile
#define _IGESGraph_Color_HeaderFile

#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif
#ifndef _Handle_IGESGraph_Color_HeaderFile
#include <Handle_IGESGraph_Color.hxx>
#endif

#ifndef _Standard_Real_HeaderFile
#include <Standard_Real.hxx>
#endif
#ifndef _Handle_TCollection_HAsciiString_HeaderFile
#include <Handle_TCollection_HAsciiString.hxx>
#endif
#ifndef _IGESData_ColorEntity_HeaderFile
#include <IGESData_ColorEntity.hxx>
#endif
#ifndef _Standard_Boolean_HeaderFile
#include <Standard_Boolean.hxx>
#endif
class TCollection_HAsciiString;


//! defines IGESColor, Type <314> Form <0> <br>
//!           in package IGESGraph <br>
class IGESGraph_Color : public IGESData_ColorEntity {

public:
 // Methods PUBLIC
 // 


Standard_EXPORT IGESGraph_Color();

//! This method is used to set the fields of the class Color <br>
//!       - red        : Red   color intensity (range 0.0 to 100.0) <br>
//!       - green      : Green color intensity (range 0.0 to 100.0) <br>
//!       - blue       : Blue  color intensity (range 0.0 to 100.0) <br>
//!       - aColorName : Name of the color (optional) <br>
Standard_EXPORT   void Init(const Standard_Real red,const Standard_Real green,const Standard_Real blue,const Handle(TCollection_HAsciiString)& aColorName) ;


Standard_EXPORT   void RGBIntensity(Standard_Real& Red,Standard_Real& Green,Standard_Real& Blue) const;


Standard_EXPORT   void CMYIntensity(Standard_Real& Cyan,Standard_Real& Magenta,Standard_Real& Yellow) const;


Standard_EXPORT   void HLSPercentage(Standard_Real& Hue,Standard_Real& Lightness,Standard_Real& Saturation) const;

//! returns True if optional character string is assigned, <br>
//!         False otherwise. <br>
Standard_EXPORT   Standard_Boolean HasColorName() const;

//! if HasColorName() is True  returns the Verbal description of <br>
//! the Color. <br>
Standard_EXPORT   Handle_TCollection_HAsciiString ColorName() const;
//Standard_EXPORT ~IGESGraph_Color();




 // Type management
 //
 Standard_EXPORT const Handle(Standard_Type)& DynamicType() const;
 //Standard_EXPORT Standard_Boolean	       IsKind(const Handle(Standard_Type)&) const;

protected:

 // Methods PROTECTED
 // 


 // Fields PROTECTED
 //


private: 

 // Methods PRIVATE
 // 


 // Fields PRIVATE
 //
Standard_Real theRed;
Standard_Real theGreen;
Standard_Real theBlue;
Handle_TCollection_HAsciiString theColorName;


};





// other Inline functions and methods (like "C++: function call" methods)
//


#endif
