// File generated by CPPExt (Transient)
//
//
//                     Copyright (C) 1991 - 2000 by  
//                      Matra Datavision SA.  All rights reserved.
//  
//                     Copyright (C) 2001 - 2004 by
//                     Open CASCADE SA.  All rights reserved.
// 
// This file is part of the Open CASCADE Technology software.
//
// This software may be distributed and/or modified under the terms and
// conditions of the Open CASCADE Public License as defined by Open CASCADE SA
// and appearing in the file LICENSE included in the packaging of this file.
//  
// This software is distributed on an "AS IS" basis, without warranty of any
// kind, and Open CASCADE SA hereby disclaims all such warranties,
// including without limitation, any warranties of merchantability, fitness
// for a particular purpose or non-infringement. Please see the License for
// the specific terms and conditions governing rights and limitations under the
// License.

#ifndef _IGESGraph_LineFontDefPattern_HeaderFile
#define _IGESGraph_LineFontDefPattern_HeaderFile

#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif
#ifndef _Handle_IGESGraph_LineFontDefPattern_HeaderFile
#include <Handle_IGESGraph_LineFontDefPattern.hxx>
#endif

#ifndef _Handle_TColStd_HArray1OfReal_HeaderFile
#include <Handle_TColStd_HArray1OfReal.hxx>
#endif
#ifndef _Handle_TCollection_HAsciiString_HeaderFile
#include <Handle_TCollection_HAsciiString.hxx>
#endif
#ifndef _IGESData_LineFontEntity_HeaderFile
#include <IGESData_LineFontEntity.hxx>
#endif
#ifndef _Standard_Integer_HeaderFile
#include <Standard_Integer.hxx>
#endif
#ifndef _Standard_Real_HeaderFile
#include <Standard_Real.hxx>
#endif
#ifndef _Standard_Boolean_HeaderFile
#include <Standard_Boolean.hxx>
#endif
class TColStd_HArray1OfReal;
class TCollection_HAsciiString;
class Standard_OutOfRange;


//! defines IGESLineFontDefPattern, Type <304> Form <2> <br>
//!           in package IGESGraph <br>
class IGESGraph_LineFontDefPattern : public IGESData_LineFontEntity {

public:
 // Methods PUBLIC
 // 


Standard_EXPORT IGESGraph_LineFontDefPattern();

//! This method is used to set the fields of the class <br>
//!           LineFontDefPattern <br>
//!       - allSegLength : Containing lengths of respective segments <br>
//!       - aPattern     : HAsciiString indicating visible-blank segments <br>
Standard_EXPORT   void Init(const Handle(TColStd_HArray1OfReal)& allSegLength,const Handle(TCollection_HAsciiString)& aPattern) ;

//! returns the number of segments in the visible-blank pattern <br>
Standard_EXPORT   Standard_Integer NbSegments() const;

//! returns the Length of Index'th segment of the basic pattern <br>
//! raises exception if Index <= 0 or Index > NbSegments <br>
Standard_EXPORT   Standard_Real Length(const Standard_Integer Index) const;

//! returns the string indicating which segments of the basic <br>
//! pattern are visible and which are blanked. <br>
//! e.g: <br>
//! theNbSegments = 5 and if Bit Pattern = 10110, which means that <br>
//! segments 2, 3 and 5 are visible, whereas segments 1 and 4 are <br>
//! blank. The method returns "2H16" as the HAsciiString. <br>
//! Note: The bits are right justified. (16h = 10110) <br>
Standard_EXPORT   Handle_TCollection_HAsciiString DisplayPattern() const;

//! The Display Pattern is decrypted to <br>
//! return True if the Index'th basic pattern is Visible, <br>
//!        False otherwise. <br>
//! If Index > NbSegments or Index <= 0 then return value is <br>
//! False. <br>
Standard_EXPORT   Standard_Boolean IsVisible(const Standard_Integer Index) const;
//Standard_EXPORT ~IGESGraph_LineFontDefPattern();




 // Type management
 //
 Standard_EXPORT const Handle(Standard_Type)& DynamicType() const;
 //Standard_EXPORT Standard_Boolean	       IsKind(const Handle(Standard_Type)&) const;

protected:

 // Methods PROTECTED
 // 


 // Fields PROTECTED
 //


private: 

 // Methods PRIVATE
 // 


 // Fields PRIVATE
 //
Handle_TColStd_HArray1OfReal theSegmentLengths;
Handle_TCollection_HAsciiString theDisplayPattern;


};





// other Inline functions and methods (like "C++: function call" methods)
//


#endif
