// File generated by CPPExt (Transient)
//
//
//                     Copyright (C) 1991 - 2000 by  
//                      Matra Datavision SA.  All rights reserved.
//  
//                     Copyright (C) 2001 - 2004 by
//                     Open CASCADE SA.  All rights reserved.
// 
// This file is part of the Open CASCADE Technology software.
//
// This software may be distributed and/or modified under the terms and
// conditions of the Open CASCADE Public License as defined by Open CASCADE SA
// and appearing in the file LICENSE included in the packaging of this file.
//  
// This software is distributed on an "AS IS" basis, without warranty of any
// kind, and Open CASCADE SA hereby disclaims all such warranties,
// including without limitation, any warranties of merchantability, fitness
// for a particular purpose or non-infringement. Please see the License for
// the specific terms and conditions governing rights and limitations under the
// License.

#ifndef _IGESSelect_RebuildDrawings_HeaderFile
#define _IGESSelect_RebuildDrawings_HeaderFile

#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif
#ifndef _Handle_IGESSelect_RebuildDrawings_HeaderFile
#include <Handle_IGESSelect_RebuildDrawings.hxx>
#endif

#ifndef _IGESSelect_ModelModifier_HeaderFile
#include <IGESSelect_ModelModifier.hxx>
#endif
#ifndef _Handle_IGESData_IGESModel_HeaderFile
#include <Handle_IGESData_IGESModel.hxx>
#endif
class IFSelect_ContextModif;
class IGESData_IGESModel;
class Interface_CopyTool;
class TCollection_AsciiString;


//! Rebuilds Drawings which were bypassed to produce new models. <br>
//!           If a set of entities, all put into a same IGESModel, were <br>
//!           attached to a same Drawing in the starting Model, this Modifier <br>
//!           rebuilds the original Drawing, but only with the transferred <br>
//!           entities. This includes that all its views are kept too, but <br>
//!           empty; and annotations are not kept. Drawing Name is renewed. <br>
//! <br>
//!           If the Input Selection is present, tries to rebuild Drawings <br>
//!           only for the selected entities. Else, tries to rebuild <br>
//!           Drawings for all the transferred entities. <br>
class IGESSelect_RebuildDrawings : public IGESSelect_ModelModifier {

public:
 // Methods PUBLIC
 // 

//! Creates an RebuildDrawings, which uses the system Date <br>
Standard_EXPORT IGESSelect_RebuildDrawings();

//! Specific action : Rebuilds the original Drawings <br>
Standard_EXPORT   void Performing(IFSelect_ContextModif& ctx,const Handle(IGESData_IGESModel)& target,Interface_CopyTool& TC) const;

//! Returns a text which is <br>
//!           "Rebuild Drawings" <br>
Standard_EXPORT   TCollection_AsciiString Label() const;
//Standard_EXPORT ~IGESSelect_RebuildDrawings();




 // Type management
 //
 Standard_EXPORT const Handle(Standard_Type)& DynamicType() const;
 //Standard_EXPORT Standard_Boolean	       IsKind(const Handle(Standard_Type)&) const;

protected:

 // Methods PROTECTED
 // 


 // Fields PROTECTED
 //


private: 

 // Methods PRIVATE
 // 


 // Fields PRIVATE
 //


};





// other Inline functions and methods (like "C++: function call" methods)
//


#endif
