// File generated by CPPExt (Transient)
//
//
//                     Copyright (C) 1991 - 2000 by  
//                      Matra Datavision SA.  All rights reserved.
//  
//                     Copyright (C) 2001 - 2004 by
//                     Open CASCADE SA.  All rights reserved.
// 
// This file is part of the Open CASCADE Technology software.
//
// This software may be distributed and/or modified under the terms and
// conditions of the Open CASCADE Public License as defined by Open CASCADE SA
// and appearing in the file LICENSE included in the packaging of this file.
//  
// This software is distributed on an "AS IS" basis, without warranty of any
// kind, and Open CASCADE SA hereby disclaims all such warranties,
// including without limitation, any warranties of merchantability, fitness
// for a particular purpose or non-infringement. Please see the License for
// the specific terms and conditions governing rights and limitations under the
// License.

#ifndef _IGESSelect_SelectFaces_HeaderFile
#define _IGESSelect_SelectFaces_HeaderFile

#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif
#ifndef _Handle_IGESSelect_SelectFaces_HeaderFile
#include <Handle_IGESSelect_SelectFaces.hxx>
#endif

#ifndef _IFSelect_SelectExplore_HeaderFile
#include <IFSelect_SelectExplore.hxx>
#endif
#ifndef _Standard_Boolean_HeaderFile
#include <Standard_Boolean.hxx>
#endif
#ifndef _Standard_Integer_HeaderFile
#include <Standard_Integer.hxx>
#endif
#ifndef _Handle_Standard_Transient_HeaderFile
#include <Handle_Standard_Transient.hxx>
#endif
class Standard_Transient;
class Interface_Graph;
class Interface_EntityIterator;
class TCollection_AsciiString;


//! This selection returns the faces contained in an IGES Entity <br>
//!           or itself if it is a Face <br>
//!           Face means : <br>
//!           - Face (510) of a ManifoldSolidBrep <br>
//!           - TrimmedSurface (144) <br>
//!           - BoundedSurface (143) <br>
//!           - Plane with a Bounding Curve (108, form not 0) <br>
//!           - Also, any Surface which is not in a TrimmedSurface, a <br>
//!             BoundedSurface, or a Face (FREE Surface) <br>
//!           -> i.e. a Face for which Natural Bounds will be considered <br>
class IGESSelect_SelectFaces : public IFSelect_SelectExplore {

public:
 // Methods PUBLIC
 // 


Standard_EXPORT IGESSelect_SelectFaces();

//! Explores an entity, to take its faces <br>
//!           Works recursively <br>
Standard_EXPORT   Standard_Boolean Explore(const Standard_Integer level,const Handle(Standard_Transient)& ent,const Interface_Graph& G,Interface_EntityIterator& explored) const;

//! Returns a text defining the criterium : "Faces" <br>
Standard_EXPORT   TCollection_AsciiString ExploreLabel() const;
//Standard_EXPORT ~IGESSelect_SelectFaces();




 // Type management
 //
 Standard_EXPORT const Handle(Standard_Type)& DynamicType() const;
 //Standard_EXPORT Standard_Boolean	       IsKind(const Handle(Standard_Type)&) const;

protected:

 // Methods PROTECTED
 // 


 // Fields PROTECTED
 //


private: 

 // Methods PRIVATE
 // 


 // Fields PRIVATE
 //


};





// other Inline functions and methods (like "C++: function call" methods)
//


#endif
