// File generated by CPPExt (Transient)
//
//
//                     Copyright (C) 1991 - 2000 by  
//                      Matra Datavision SA.  All rights reserved.
//  
//                     Copyright (C) 2001 - 2004 by
//                     Open CASCADE SA.  All rights reserved.
// 
// This file is part of the Open CASCADE Technology software.
//
// This software may be distributed and/or modified under the terms and
// conditions of the Open CASCADE Public License as defined by Open CASCADE SA
// and appearing in the file LICENSE included in the packaging of this file.
//  
// This software is distributed on an "AS IS" basis, without warranty of any
// kind, and Open CASCADE SA hereby disclaims all such warranties,
// including without limitation, any warranties of merchantability, fitness
// for a particular purpose or non-infringement. Please see the License for
// the specific terms and conditions governing rights and limitations under the
// License.

#ifndef _IGESSolid_Sphere_HeaderFile
#define _IGESSolid_Sphere_HeaderFile

#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif
#ifndef _Handle_IGESSolid_Sphere_HeaderFile
#include <Handle_IGESSolid_Sphere.hxx>
#endif

#ifndef _Standard_Real_HeaderFile
#include <Standard_Real.hxx>
#endif
#ifndef _gp_XYZ_HeaderFile
#include <gp_XYZ.hxx>
#endif
#ifndef _IGESData_IGESEntity_HeaderFile
#include <IGESData_IGESEntity.hxx>
#endif
class gp_XYZ;
class gp_Pnt;


//! defines Sphere, Type <158> Form Number <0> <br>
//!          in package IGESSolid <br>
//!          This defines a sphere with a center and radius <br>
class IGESSolid_Sphere : public IGESData_IGESEntity {

public:
 // Methods PUBLIC
 // 


Standard_EXPORT IGESSolid_Sphere();

//! This method is used to set the fields of the class Sphere <br>
//!       - aRadius : the radius of the sphere <br>
//!       - aCenter : the center point coordinates (default (0,0,0)) <br>
Standard_EXPORT   void Init(const Standard_Real aRadius,const gp_XYZ& aCenter) ;

//! returns the radius of the sphere <br>
Standard_EXPORT   Standard_Real Radius() const;

//! returns the center of the sphere <br>
Standard_EXPORT   gp_Pnt Center() const;

//! returns the center of the sphere after applying <br>
//! TransformationMatrix <br>
Standard_EXPORT   gp_Pnt TransformedCenter() const;
//Standard_EXPORT ~IGESSolid_Sphere();




 // Type management
 //
 Standard_EXPORT const Handle(Standard_Type)& DynamicType() const;
 //Standard_EXPORT Standard_Boolean	       IsKind(const Handle(Standard_Type)&) const;

protected:

 // Methods PROTECTED
 // 


 // Fields PROTECTED
 //


private: 

 // Methods PRIVATE
 // 


 // Fields PRIVATE
 //
Standard_Real theRadius;
gp_XYZ theCenter;


};





// other Inline functions and methods (like "C++: function call" methods)
//


#endif
