// File generated by CPPExt (Storable)
//
//                     Copyright (C) 1991 - 2000 by  
//                      Matra Datavision SA.  All rights reserved.
//  
//                     Copyright (C) 2001 - 2004 by
//                     Open CASCADE SA.  All rights reserved.
// 
// This file is part of the Open CASCADE Technology software.
//
// This software may be distributed and/or modified under the terms and
// conditions of the Open CASCADE Public License as defined by Open CASCADE SA
// and appearing in the file LICENSE included in the packaging of this file.
//  
// This software is distributed on an "AS IS" basis, without warranty of any
// kind, and Open CASCADE SA hereby disclaims all such warranties,
// including without limitation, any warranties of merchantability, fitness
// for a particular purpose or non-infringement. Please see the License for
// the specific terms and conditions governing rights and limitations under the
// License.

#ifndef _IntAna2d_IntPoint_HeaderFile
#define _IntAna2d_IntPoint_HeaderFile

#ifndef _Standard_Real_HeaderFile
#include <Standard_Real.hxx>
#endif
#ifndef _gp_Pnt2d_HeaderFile
#include <gp_Pnt2d.hxx>
#endif
#ifndef _Standard_Boolean_HeaderFile
#include <Standard_Boolean.hxx>
#endif
#ifndef _Standard_Storable_HeaderFile
#include <Standard_Storable.hxx>
#endif
#ifndef _Standard_PrimitiveTypes_HeaderFile
#include <Standard_PrimitiveTypes.hxx>
#endif
class Standard_DomainError;
class gp_Pnt2d;


#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif
#ifndef _Standard_Macro_HeaderFile
#include <Standard_Macro.hxx>
#endif

Standard_EXPORT Handle_Standard_Type& IntAna2d_IntPoint_Type_();

//! Geometrical intersection between two 2d elements. <br>
class IntAna2d_IntPoint  {

public:
    void* operator new(size_t,void* anAddress) 
      {
        return anAddress;
      }
    void* operator new(size_t size) 
      { 
        return Standard::Allocate(size); 
      }
    void  operator delete(void *anAddress) 
      { 
        if (anAddress) Standard::Free((Standard_Address&)anAddress); 
      }

 // Methods PUBLIC
 // 

//! Create an intersection point between 2 parametric 2d lines. <br>
//!          X,Y are the coordinate of the point. U1 is the parameter <br>
//!          on the first element, U2 the parameter on the second one. <br>
Standard_EXPORT IntAna2d_IntPoint(const Standard_Real X,const Standard_Real Y,const Standard_Real U1,const Standard_Real U2);

//! Create an intersection point between a parametric 2d line, <br>
//!          and a line given by an implicit equation (ImplicitCurve). <br>
//!          X,Y are the coordinate of the point. U1 is the parameter <br>
//!          on the parametric element. <br>//! Empty constructor. It's necessary to use one of <br>
//!          the SetValue method after this one. <br>
Standard_EXPORT IntAna2d_IntPoint(const Standard_Real X,const Standard_Real Y,const Standard_Real U1);


Standard_EXPORT IntAna2d_IntPoint();

//! Set the values for a "non-implicit" point. <br>
Standard_EXPORT virtual  void SetValue(const Standard_Real X,const Standard_Real Y,const Standard_Real U1,const Standard_Real U2) ;

//! Set the values for an "implicit" point. <br>
Standard_EXPORT virtual  void SetValue(const Standard_Real X,const Standard_Real Y,const Standard_Real U1) ;
//! Returns the geometric point. <br>
 const gp_Pnt2d& Value() const;
//! Returns True if the second curve is implicit. <br>
  Standard_Boolean SecondIsImplicit() const;
//! Returns the parameter on the first element. <br>
  Standard_Real ParamOnFirst() const;
//! Returns the parameter on the second element. <br>
//!          If the second element is an implicit curve, an exception <br>
//!          is raised. <br>
  Standard_Real ParamOnSecond() const;
    Standard_Real _CSFDB_GetIntAna2d_IntPointmyu1() const { return myu1; }
    void _CSFDB_SetIntAna2d_IntPointmyu1(const Standard_Real p) { myu1 = p; }
    Standard_Real _CSFDB_GetIntAna2d_IntPointmyu2() const { return myu2; }
    void _CSFDB_SetIntAna2d_IntPointmyu2(const Standard_Real p) { myu2 = p; }
    const gp_Pnt2d& _CSFDB_GetIntAna2d_IntPointmyp() const { return myp; }
    Standard_Boolean _CSFDB_GetIntAna2d_IntPointmyimplicit() const { return myimplicit; }
    void _CSFDB_SetIntAna2d_IntPointmyimplicit(const Standard_Boolean p) { myimplicit = p; }




 // Type management
 //
 Standard_EXPORT friend Handle_Standard_Type& IntAna2d_IntPoint_Type_();

protected:

 // Methods PROTECTED
 // 


 // Fields PROTECTED
 //


private: 

 // Methods PRIVATE
 // 


 // Fields PRIVATE
 //
Standard_Real myu1;
Standard_Real myu2;
gp_Pnt2d myp;
Standard_Boolean myimplicit;


};


#include <IntAna2d_IntPoint.lxx>



// other Inline functions and methods (like "C++: function call" methods)
//


#endif
