// File generated by CPPExt (Value)
//
//                     Copyright (C) 1991 - 2000 by  
//                      Matra Datavision SA.  All rights reserved.
//  
//                     Copyright (C) 2001 - 2004 by
//                     Open CASCADE SA.  All rights reserved.
// 
// This file is part of the Open CASCADE Technology software.
//
// This software may be distributed and/or modified under the terms and
// conditions of the Open CASCADE Public License as defined by Open CASCADE SA
// and appearing in the file LICENSE included in the packaging of this file.
//  
// This software is distributed on an "AS IS" basis, without warranty of any
// kind, and Open CASCADE SA hereby disclaims all such warranties,
// including without limitation, any warranties of merchantability, fitness
// for a particular purpose or non-infringement. Please see the License for
// the specific terms and conditions governing rights and limitations under the
// License.

#ifndef _IntSurf_Quadric_HeaderFile
#define _IntSurf_Quadric_HeaderFile

#ifndef _gp_Ax3_HeaderFile
#include <gp_Ax3.hxx>
#endif
#ifndef _gp_Lin_HeaderFile
#include <gp_Lin.hxx>
#endif
#ifndef _Standard_Real_HeaderFile
#include <Standard_Real.hxx>
#endif
#ifndef _Standard_Boolean_HeaderFile
#include <Standard_Boolean.hxx>
#endif
#ifndef _GeomAbs_SurfaceType_HeaderFile
#include <GeomAbs_SurfaceType.hxx>
#endif
#ifndef _gp_Pln_HeaderFile
#include <gp_Pln.hxx>
#endif
#ifndef _gp_Sphere_HeaderFile
#include <gp_Sphere.hxx>
#endif
#ifndef _gp_Cylinder_HeaderFile
#include <gp_Cylinder.hxx>
#endif
#ifndef _gp_Cone_HeaderFile
#include <gp_Cone.hxx>
#endif
#ifndef _Standard_Integer_HeaderFile
#include <Standard_Integer.hxx>
#endif
class gp_Pln;
class gp_Cylinder;
class gp_Sphere;
class gp_Cone;
class gp_Pnt;
class gp_Vec;


#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif
#ifndef _Standard_Macro_HeaderFile
#include <Standard_Macro.hxx>
#endif


class IntSurf_Quadric  {

public:

    void* operator new(size_t,void* anAddress) 
      {
        return anAddress;
      }
    void* operator new(size_t size) 
      { 
        return Standard::Allocate(size); 
      }
    void  operator delete(void *anAddress) 
      { 
        if (anAddress) Standard::Free((Standard_Address&)anAddress); 
      }
 // Methods PUBLIC
 // 


Standard_EXPORT IntSurf_Quadric();


Standard_EXPORT IntSurf_Quadric(const gp_Pln& P);


Standard_EXPORT IntSurf_Quadric(const gp_Cylinder& C);


Standard_EXPORT IntSurf_Quadric(const gp_Sphere& S);


Standard_EXPORT IntSurf_Quadric(const gp_Cone& C);


Standard_EXPORT   void SetValue(const gp_Pln& P) ;


Standard_EXPORT   void SetValue(const gp_Cylinder& C) ;


Standard_EXPORT   void SetValue(const gp_Sphere& S) ;


Standard_EXPORT   void SetValue(const gp_Cone& C) ;


Standard_EXPORT   Standard_Real Distance(const gp_Pnt& P) const;


Standard_EXPORT   gp_Vec Gradient(const gp_Pnt& P) const;


Standard_EXPORT   void ValAndGrad(const gp_Pnt& P,Standard_Real& Dist,gp_Vec& Grad) const;

  GeomAbs_SurfaceType TypeQuadric() const;

  gp_Pln Plane() const;

  gp_Sphere Sphere() const;

  gp_Cylinder Cylinder() const;

  gp_Cone Cone() const;


Standard_EXPORT   gp_Pnt Value(const Standard_Real U,const Standard_Real V) const;


Standard_EXPORT   void D1(const Standard_Real U,const Standard_Real V,gp_Pnt& P,gp_Vec& D1U,gp_Vec& D1V) const;


Standard_EXPORT   gp_Vec DN(const Standard_Real U,const Standard_Real V,const Standard_Integer Nu,const Standard_Integer Nv) const;


Standard_EXPORT   gp_Vec Normale(const Standard_Real U,const Standard_Real V) const;


Standard_EXPORT   void Parameters(const gp_Pnt& P,Standard_Real& U,Standard_Real& V) const;


Standard_EXPORT   gp_Vec Normale(const gp_Pnt& P) const;





protected:

 // Methods PROTECTED
 // 


 // Fields PROTECTED
 //


private: 

 // Methods PRIVATE
 // 


 // Fields PRIVATE
 //
gp_Ax3 ax3;
gp_Lin lin;
Standard_Real prm1;
Standard_Real prm2;
Standard_Real prm3;
Standard_Real prm4;
Standard_Boolean ax3direc;
GeomAbs_SurfaceType typ;


};


#include <IntSurf_Quadric.lxx>



// other Inline functions and methods (like "C++: function call" methods)
//


#endif
