// File generated by CPPExt (Value)
//
//                     Copyright (C) 1991 - 2000 by  
//                      Matra Datavision SA.  All rights reserved.
//  
//                     Copyright (C) 2001 - 2004 by
//                     Open CASCADE SA.  All rights reserved.
// 
// This file is part of the Open CASCADE Technology software.
//
// This software may be distributed and/or modified under the terms and
// conditions of the Open CASCADE Public License as defined by Open CASCADE SA
// and appearing in the file LICENSE included in the packaging of this file.
//  
// This software is distributed on an "AS IS" basis, without warranty of any
// kind, and Open CASCADE SA hereby disclaims all such warranties,
// including without limitation, any warranties of merchantability, fitness
// for a particular purpose or non-infringement. Please see the License for
// the specific terms and conditions governing rights and limitations under the
// License.

#ifndef _IntTools_Array1OfRange_HeaderFile
#define _IntTools_Array1OfRange_HeaderFile

#ifndef _Standard_Integer_HeaderFile
#include <Standard_Integer.hxx>
#endif
#ifndef _Standard_Address_HeaderFile
#include <Standard_Address.hxx>
#endif
#ifndef _Standard_Boolean_HeaderFile
#include <Standard_Boolean.hxx>
#endif
class Standard_RangeError;
class Standard_DimensionMismatch;
class Standard_OutOfRange;
class Standard_OutOfMemory;
class IntTools_Range;


#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif
#ifndef _Standard_Macro_HeaderFile
#include <Standard_Macro.hxx>
#endif


class IntTools_Array1OfRange  {

public:

    void* operator new(size_t,void* anAddress) 
      {
        return anAddress;
      }
    void* operator new(size_t size) 
      { 
        return Standard::Allocate(size); 
      }
    void  operator delete(void *anAddress) 
      { 
        if (anAddress) Standard::Free((Standard_Address&)anAddress); 
      }
 // Methods PUBLIC
 // 


Standard_EXPORT IntTools_Array1OfRange(const Standard_Integer Low,const Standard_Integer Up);


Standard_EXPORT IntTools_Array1OfRange(const IntTools_Range& Item,const Standard_Integer Low,const Standard_Integer Up);


Standard_EXPORT   void Init(const IntTools_Range& V) ;


Standard_EXPORT   void Destroy() ;
~IntTools_Array1OfRange()
{
  Destroy();
}


  Standard_Boolean IsAllocated() const;


Standard_EXPORT  const IntTools_Array1OfRange& Assign(const IntTools_Array1OfRange& Other) ;
 const IntTools_Array1OfRange& operator =(const IntTools_Array1OfRange& Other) 
{
  return Assign(Other);
}


  Standard_Integer Length() const;

  Standard_Integer Lower() const;

  Standard_Integer Upper() const;

  void SetValue(const Standard_Integer Index,const IntTools_Range& Value) ;

 const IntTools_Range& Value(const Standard_Integer Index) const;
 const IntTools_Range& operator ()(const Standard_Integer Index) const
{
  return Value(Index);
}


  IntTools_Range& ChangeValue(const Standard_Integer Index) ;
  IntTools_Range& operator ()(const Standard_Integer Index) 
{
  return ChangeValue(Index);
}






protected:

 // Methods PROTECTED
 // 


 // Fields PROTECTED
 //


private: 

 // Methods PRIVATE
 // 


Standard_EXPORT IntTools_Array1OfRange(const IntTools_Array1OfRange& AnArray);


 // Fields PRIVATE
 //
Standard_Integer myLowerBound;
Standard_Integer myUpperBound;
Standard_Address myStart;
Standard_Boolean isAllocated;


};

#define Array1Item IntTools_Range
#define Array1Item_hxx <IntTools_Range.hxx>
#define TCollection_Array1 IntTools_Array1OfRange
#define TCollection_Array1_hxx <IntTools_Array1OfRange.hxx>

#include <TCollection_Array1.lxx>

#undef Array1Item
#undef Array1Item_hxx
#undef TCollection_Array1
#undef TCollection_Array1_hxx


// other Inline functions and methods (like "C++: function call" methods)
//


#endif
