// File generated by CPPExt (Value)
//
//                     Copyright (C) 1991 - 2000 by  
//                      Matra Datavision SA.  All rights reserved.
//  
//                     Copyright (C) 2001 - 2004 by
//                     Open CASCADE SA.  All rights reserved.
// 
// This file is part of the Open CASCADE Technology software.
//
// This software may be distributed and/or modified under the terms and
// conditions of the Open CASCADE Public License as defined by Open CASCADE SA
// and appearing in the file LICENSE included in the packaging of this file.
//  
// This software is distributed on an "AS IS" basis, without warranty of any
// kind, and Open CASCADE SA hereby disclaims all such warranties,
// including without limitation, any warranties of merchantability, fitness
// for a particular purpose or non-infringement. Please see the License for
// the specific terms and conditions governing rights and limitations under the
// License.

#ifndef _LocOpe_Gluer_HeaderFile
#define _LocOpe_Gluer_HeaderFile

#ifndef _Standard_Boolean_HeaderFile
#include <Standard_Boolean.hxx>
#endif
#ifndef _TopoDS_Shape_HeaderFile
#include <TopoDS_Shape.hxx>
#endif
#ifndef _TopAbs_Orientation_HeaderFile
#include <TopAbs_Orientation.hxx>
#endif
#ifndef _LocOpe_Operation_HeaderFile
#include <LocOpe_Operation.hxx>
#endif
#ifndef _TopTools_IndexedDataMapOfShapeShape_HeaderFile
#include <TopTools_IndexedDataMapOfShapeShape.hxx>
#endif
#ifndef _TopTools_DataMapOfShapeShape_HeaderFile
#include <TopTools_DataMapOfShapeShape.hxx>
#endif
#ifndef _TopTools_DataMapOfShapeListOfShape_HeaderFile
#include <TopTools_DataMapOfShapeListOfShape.hxx>
#endif
#ifndef _TopTools_ListOfShape_HeaderFile
#include <TopTools_ListOfShape.hxx>
#endif
class StdFail_NotDone;
class Standard_NoSuchObject;
class Standard_ConstructionError;
class TopoDS_Shape;
class TopoDS_Face;
class TopoDS_Edge;
class TopTools_ListOfShape;


#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif
#ifndef _Standard_Macro_HeaderFile
#include <Standard_Macro.hxx>
#endif


class LocOpe_Gluer  {

public:

    void* operator new(size_t,void* anAddress) 
      {
        return anAddress;
      }
    void* operator new(size_t size) 
      { 
        return Standard::Allocate(size); 
      }
    void  operator delete(void *anAddress) 
      { 
        if (anAddress) Standard::Free((Standard_Address&)anAddress); 
      }
 // Methods PUBLIC
 // 

LocOpe_Gluer();

LocOpe_Gluer(const TopoDS_Shape& Sbase,const TopoDS_Shape& Snew);


Standard_EXPORT   void Init(const TopoDS_Shape& Sbase,const TopoDS_Shape& Snew) ;


Standard_EXPORT   void Bind(const TopoDS_Face& Fnew,const TopoDS_Face& Fbase) ;


Standard_EXPORT   void Bind(const TopoDS_Edge& Enew,const TopoDS_Edge& Ebase) ;

  LocOpe_Operation OpeType() const;


Standard_EXPORT   void Perform() ;

  Standard_Boolean IsDone() const;

 const TopoDS_Shape& ResultingShape() const;


Standard_EXPORT  const TopTools_ListOfShape& DescendantFaces(const TopoDS_Face& F) const;

 const TopoDS_Shape& BasisShape() const;

 const TopoDS_Shape& GluedShape() const;


Standard_EXPORT  const TopTools_ListOfShape& Edges() const;


Standard_EXPORT  const TopTools_ListOfShape& TgtEdges() const;





protected:

 // Methods PROTECTED
 // 


 // Fields PROTECTED
 //


private: 

 // Methods PRIVATE
 // 


Standard_EXPORT   void AddEdges() ;


 // Fields PRIVATE
 //
Standard_Boolean myDone;
TopoDS_Shape mySb;
TopoDS_Shape mySn;
TopoDS_Shape myRes;
TopAbs_Orientation myOri;
LocOpe_Operation myOpe;
TopTools_IndexedDataMapOfShapeShape myMapEF;
TopTools_DataMapOfShapeShape myMapEE;
TopTools_DataMapOfShapeListOfShape myDescF;
TopTools_ListOfShape myEdges;
TopTools_ListOfShape myTgtEdges;


};


#include <LocOpe_Gluer.lxx>



// other Inline functions and methods (like "C++: function call" methods)
//


#endif
