// File generated by CPPExt (Transient)
//
//
//                     Copyright (C) 1991 - 2000 by  
//                      Matra Datavision SA.  All rights reserved.
//  
//                     Copyright (C) 2001 - 2004 by
//                     Open CASCADE SA.  All rights reserved.
// 
// This file is part of the Open CASCADE Technology software.
//
// This software may be distributed and/or modified under the terms and
// conditions of the Open CASCADE Public License as defined by Open CASCADE SA
// and appearing in the file LICENSE included in the packaging of this file.
//  
// This software is distributed on an "AS IS" basis, without warranty of any
// kind, and Open CASCADE SA hereby disclaims all such warranties,
// including without limitation, any warranties of merchantability, fitness
// for a particular purpose or non-infringement. Please see the License for
// the specific terms and conditions governing rights and limitations under the
// License.

#ifndef _MoniTool_SignText_HeaderFile
#define _MoniTool_SignText_HeaderFile

#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif
#ifndef _Handle_MoniTool_SignText_HeaderFile
#include <Handle_MoniTool_SignText.hxx>
#endif

#ifndef _MMgt_TShared_HeaderFile
#include <MMgt_TShared.hxx>
#endif
#ifndef _Standard_CString_HeaderFile
#include <Standard_CString.hxx>
#endif
#ifndef _Handle_Standard_Transient_HeaderFile
#include <Handle_Standard_Transient.hxx>
#endif
class TCollection_AsciiString;
class Standard_Transient;


//! Provides the basic service to get a text which identifies <br>
//!           an object in a context <br>
//!           It can be used for other classes (general signatures ...) <br>
//!           It can also be used to build a message in which an object <br>
//!           is to be identified <br>
class MoniTool_SignText : public MMgt_TShared {

public:
 // Methods PUBLIC
 // 

//! Returns an identification of the Signature (a word), given at <br>
//!           initialization time <br>
Standard_EXPORT virtual  Standard_CString Name() const = 0;

//! Gives a text as a signature for a transient object alone, i.e. <br>
//!           without defined context. <br>
//!           By default, calls Text with undefined context (Null Handle) and <br>
//!           if empty, then returns DynamicType <br>
Standard_EXPORT virtual  TCollection_AsciiString TextAlone(const Handle(Standard_Transient)& ent) const;

//! Gives a text as a signature for a transient object in a context <br>
//!           If the context is senseless, it can be given as Null Handle <br>
//!           empty result if nothing to give (at least the DynamicType could <br>
//!           be sent ?) <br>
Standard_EXPORT virtual  TCollection_AsciiString Text(const Handle(Standard_Transient)& ent,const Handle(Standard_Transient)& context) const = 0;
//Standard_EXPORT ~MoniTool_SignText();




 // Type management
 //
 Standard_EXPORT const Handle(Standard_Type)& DynamicType() const;
 //Standard_EXPORT Standard_Boolean	       IsKind(const Handle(Standard_Type)&) const;

protected:

 // Methods PROTECTED
 // 


 // Fields PROTECTED
 //


private: 

 // Methods PRIVATE
 // 


 // Fields PRIVATE
 //


};





// other Inline functions and methods (like "C++: function call" methods)
//


#endif
