// File generated by CPPExt (Transient)
//
//
//                     Copyright (C) 1991 - 2000 by  
//                      Matra Datavision SA.  All rights reserved.
//  
//                     Copyright (C) 2001 - 2004 by
//                     Open CASCADE SA.  All rights reserved.
// 
// This file is part of the Open CASCADE Technology software.
//
// This software may be distributed and/or modified under the terms and
// conditions of the Open CASCADE Public License as defined by Open CASCADE SA
// and appearing in the file LICENSE included in the packaging of this file.
//  
// This software is distributed on an "AS IS" basis, without warranty of any
// kind, and Open CASCADE SA hereby disclaims all such warranties,
// including without limitation, any warranties of merchantability, fitness
// for a particular purpose or non-infringement. Please see the License for
// the specific terms and conditions governing rights and limitations under the
// License.

#ifndef _RWStepAP214_GeneralModule_HeaderFile
#define _RWStepAP214_GeneralModule_HeaderFile

#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif
#ifndef _Handle_RWStepAP214_GeneralModule_HeaderFile
#include <Handle_RWStepAP214_GeneralModule.hxx>
#endif

#ifndef _StepData_GeneralModule_HeaderFile
#include <StepData_GeneralModule.hxx>
#endif
#ifndef _Standard_Integer_HeaderFile
#include <Standard_Integer.hxx>
#endif
#ifndef _Handle_Standard_Transient_HeaderFile
#include <Handle_Standard_Transient.hxx>
#endif
#ifndef _Handle_Interface_Check_HeaderFile
#include <Handle_Interface_Check.hxx>
#endif
#ifndef _Standard_Boolean_HeaderFile
#include <Standard_Boolean.hxx>
#endif
#ifndef _Handle_TCollection_HAsciiString_HeaderFile
#include <Handle_TCollection_HAsciiString.hxx>
#endif
class Standard_Transient;
class Interface_EntityIterator;
class Interface_ShareTool;
class Interface_Check;
class Interface_CopyTool;
class TCollection_HAsciiString;


//! Defines General Services for StepAP214 Entities <br>
//!           (Share,Check,Copy; Trace already inherited) <br>
//!           Depends (for case numbers) of Protocol from StepAP214 <br>
class RWStepAP214_GeneralModule : public StepData_GeneralModule {

public:
 // Methods PUBLIC
 // 

//! Creates a GeneralModule <br>
Standard_EXPORT RWStepAP214_GeneralModule();

//! Specific filling of the list of Entities shared by an Entity <br>
//!           <ent>, according to a Case Number <CN> (provided by StepAP214 <br>
//!           Protocol). <br>
Standard_EXPORT   void FillSharedCase(const Standard_Integer CN,const Handle(Standard_Transient)& ent,Interface_EntityIterator& iter) const;

//! Specific Checking of an Entity <ent> <br>
Standard_EXPORT   void CheckCase(const Standard_Integer CN,const Handle(Standard_Transient)& ent,const Interface_ShareTool& shares,Handle(Interface_Check)& ach) const;

//! Specific Copy ("Deep") from <entfrom> to <entto> (same type) <br>
//!           by using a CopyTool which provides its working Map. <br>
//!           Use method Transferred from CopyTool to work <br>
Standard_EXPORT   void CopyCase(const Standard_Integer CN,const Handle(Standard_Transient)& entfrom,const Handle(Standard_Transient)& entto,Interface_CopyTool& TC) const;


Standard_EXPORT   Standard_Boolean NewVoid(const Standard_Integer CN,Handle(Standard_Transient)& ent) const;


Standard_EXPORT virtual  Standard_Integer CategoryNumber(const Standard_Integer CN,const Handle(Standard_Transient)& ent,const Interface_ShareTool& shares) const;

//! Returns the name of a STEP Entity according to its type <br>
Standard_EXPORT virtual  Handle_TCollection_HAsciiString Name(const Standard_Integer CN,const Handle(Standard_Transient)& ent,const Interface_ShareTool& shares) const;
//Standard_EXPORT ~RWStepAP214_GeneralModule();




 // Type management
 //
 Standard_EXPORT const Handle(Standard_Type)& DynamicType() const;
 //Standard_EXPORT Standard_Boolean	       IsKind(const Handle(Standard_Type)&) const;

protected:

 // Methods PROTECTED
 // 


 // Fields PROTECTED
 //


private: 

 // Methods PRIVATE
 // 


 // Fields PRIVATE
 //


};





// other Inline functions and methods (like "C++: function call" methods)
//


#endif
