// File generated by CPPExt (Transient)
//
//
//                     Copyright (C) 1991 - 2000 by  
//                      Matra Datavision SA.  All rights reserved.
//  
//                     Copyright (C) 2001 - 2004 by
//                     Open CASCADE SA.  All rights reserved.
// 
// This file is part of the Open CASCADE Technology software.
//
// This software may be distributed and/or modified under the terms and
// conditions of the Open CASCADE Public License as defined by Open CASCADE SA
// and appearing in the file LICENSE included in the packaging of this file.
//  
// This software is distributed on an "AS IS" basis, without warranty of any
// kind, and Open CASCADE SA hereby disclaims all such warranties,
// including without limitation, any warranties of merchantability, fitness
// for a particular purpose or non-infringement. Please see the License for
// the specific terms and conditions governing rights and limitations under the
// License.

#ifndef _RWStepAP214_ReadWriteModule_HeaderFile
#define _RWStepAP214_ReadWriteModule_HeaderFile

#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif
#ifndef _Handle_RWStepAP214_ReadWriteModule_HeaderFile
#include <Handle_RWStepAP214_ReadWriteModule.hxx>
#endif

#ifndef _StepData_ReadWriteModule_HeaderFile
#include <StepData_ReadWriteModule.hxx>
#endif
#ifndef _Standard_Integer_HeaderFile
#include <Standard_Integer.hxx>
#endif
#ifndef _Standard_Boolean_HeaderFile
#include <Standard_Boolean.hxx>
#endif
#ifndef _Handle_StepData_StepReaderData_HeaderFile
#include <Handle_StepData_StepReaderData.hxx>
#endif
#ifndef _Handle_Interface_Check_HeaderFile
#include <Handle_Interface_Check.hxx>
#endif
#ifndef _Handle_Standard_Transient_HeaderFile
#include <Handle_Standard_Transient.hxx>
#endif
class TCollection_AsciiString;
class TColStd_SequenceOfAsciiString;
class StepData_StepReaderData;
class Interface_Check;
class Standard_Transient;
class StepData_StepWriter;


//! General module to read and write StepAP214 entities <br>
class RWStepAP214_ReadWriteModule : public StepData_ReadWriteModule {

public:
 // Methods PUBLIC
 // 


Standard_EXPORT RWStepAP214_ReadWriteModule();

//! associates a positive Case Number to each type of StepAP214 entity, <br>
//! given as a String defined in the EXPRESS form <br>
Standard_EXPORT   Standard_Integer CaseStep(const TCollection_AsciiString& atype) const;

//! associates a positive Case Number to each type of StepAP214 Complex entity, <br>
//! given as a String defined in the EXPRESS form <br>
Standard_EXPORT virtual  Standard_Integer CaseStep(const TColStd_SequenceOfAsciiString& types) const;

//! returns True if the Case Number corresponds to a Complex Type <br>
Standard_EXPORT virtual  Standard_Boolean IsComplex(const Standard_Integer CN) const;

//! returns a StepType (defined in EXPRESS form which belongs to a <br>
//! Type of Entity, identified by its CaseNumber determined by Protocol <br>
Standard_EXPORT  const TCollection_AsciiString& StepType(const Standard_Integer CN) const;


Standard_EXPORT virtual  Standard_Boolean ComplexType(const Standard_Integer CN,TColStd_SequenceOfAsciiString& types) const;


Standard_EXPORT   void ReadStep(const Standard_Integer CN,const Handle(StepData_StepReaderData)& data,const Standard_Integer num,Handle(Interface_Check)& ach,const Handle(Standard_Transient)& ent) const;


Standard_EXPORT   void WriteStep(const Standard_Integer CN,StepData_StepWriter& SW,const Handle(Standard_Transient)& ent) const;
//Standard_EXPORT ~RWStepAP214_ReadWriteModule();




 // Type management
 //
 Standard_EXPORT const Handle(Standard_Type)& DynamicType() const;
 //Standard_EXPORT Standard_Boolean	       IsKind(const Handle(Standard_Type)&) const;

protected:

 // Methods PROTECTED
 // 


 // Fields PROTECTED
 //


private: 

 // Methods PRIVATE
 // 


 // Fields PRIVATE
 //


};





// other Inline functions and methods (like "C++: function call" methods)
//


#endif
