// File generated by CPPExt (Value)
//
//                     Copyright (C) 1991 - 2000 by  
//                      Matra Datavision SA.  All rights reserved.
//  
//                     Copyright (C) 2001 - 2004 by
//                     Open CASCADE SA.  All rights reserved.
// 
// This file is part of the Open CASCADE Technology software.
//
// This software may be distributed and/or modified under the terms and
// conditions of the Open CASCADE Public License as defined by Open CASCADE SA
// and appearing in the file LICENSE included in the packaging of this file.
//  
// This software is distributed on an "AS IS" basis, without warranty of any
// kind, and Open CASCADE SA hereby disclaims all such warranties,
// including without limitation, any warranties of merchantability, fitness
// for a particular purpose or non-infringement. Please see the License for
// the specific terms and conditions governing rights and limitations under the
// License.

#ifndef _ShapeFix_WireVertex_HeaderFile
#define _ShapeFix_WireVertex_HeaderFile

#ifndef _ShapeAnalysis_WireVertex_HeaderFile
#include <ShapeAnalysis_WireVertex.hxx>
#endif
#ifndef _Standard_Real_HeaderFile
#include <Standard_Real.hxx>
#endif
#ifndef _Handle_ShapeExtend_WireData_HeaderFile
#include <Handle_ShapeExtend_WireData.hxx>
#endif
#ifndef _Standard_Integer_HeaderFile
#include <Standard_Integer.hxx>
#endif
class TopoDS_Wire;
class ShapeExtend_WireData;
class ShapeAnalysis_WireVertex;


#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif
#ifndef _Standard_Macro_HeaderFile
#include <Standard_Macro.hxx>
#endif

//! Fixes vertices in the wire on the basis of pre-analysis <br>
//!          made by ShapeAnalysis_WireVertex (given as argument). <br>
//!          The Wire has formerly been loaded in a ShapeExtend_WireData. <br>
class ShapeFix_WireVertex  {

public:

    void* operator new(size_t,void* anAddress) 
      {
        return anAddress;
      }
    void* operator new(size_t size) 
      { 
        return Standard::Allocate(size); 
      }
    void  operator delete(void *anAddress) 
      { 
        if (anAddress) Standard::Free((Standard_Address&)anAddress); 
      }
 // Methods PUBLIC
 // 


Standard_EXPORT ShapeFix_WireVertex();

//! Loads the wire, ininializes internal analyzer <br>
//!          (ShapeAnalysis_WireVertex) with the given precision, <br>
//!          and performs analysis <br>
Standard_EXPORT   void Init(const TopoDS_Wire& wire,const Standard_Real preci) ;

//! Loads the wire, ininializes internal analyzer <br>
//!          (ShapeAnalysis_WireVertex) with the given precision, <br>
//!          and performs analysis <br>
Standard_EXPORT   void Init(const Handle(ShapeExtend_WireData)& sbwd,const Standard_Real preci) ;

//! Loads all the data on wire, already analysed by <br>
//!          ShapeAnalysis_WireVertex <br>
Standard_EXPORT   void Init(const ShapeAnalysis_WireVertex& sawv) ;

//! returns internal analyzer <br>
Standard_EXPORT  const ShapeAnalysis_WireVertex& Analyzer() const;

//! returns data on wire (fixed) <br>
Standard_EXPORT  const Handle_ShapeExtend_WireData& WireData() const;

//! returns resulting wire (fixed) <br>
Standard_EXPORT   TopoDS_Wire Wire() const;

//! Fixes "Same" or "Close" status (same vertex may be set, <br>
//!          without changing parameters) <br>
//!          Returns the count of fixed vertices, 0 if none <br>
Standard_EXPORT   Standard_Integer FixSame() ;

//! Fixes all statuses except "Disjoined", i.e. the cases in which a <br>
//!          common value has been set, with or without changing parameters <br>
//!          Returns the count of fixed vertices, 0 if none <br>
Standard_EXPORT   Standard_Integer Fix() ;





protected:

 // Methods PROTECTED
 // 


 // Fields PROTECTED
 //


private: 

 // Methods PRIVATE
 // 


 // Fields PRIVATE
 //
ShapeAnalysis_WireVertex myAnalyzer;


};





// other Inline functions and methods (like "C++: function call" methods)
//


#endif
