// File generated by CPPExt (Value)
//
//                     Copyright (C) 1991 - 2000 by  
//                      Matra Datavision SA.  All rights reserved.
//  
//                     Copyright (C) 2001 - 2004 by
//                     Open CASCADE SA.  All rights reserved.
// 
// This file is part of the Open CASCADE Technology software.
//
// This software may be distributed and/or modified under the terms and
// conditions of the Open CASCADE Public License as defined by Open CASCADE SA
// and appearing in the file LICENSE included in the packaging of this file.
//  
// This software is distributed on an "AS IS" basis, without warranty of any
// kind, and Open CASCADE SA hereby disclaims all such warranties,
// including without limitation, any warranties of merchantability, fitness
// for a particular purpose or non-infringement. Please see the License for
// the specific terms and conditions governing rights and limitations under the
// License.

#ifndef _StepFEA_SymmetricTensor43d_HeaderFile
#define _StepFEA_SymmetricTensor43d_HeaderFile

#ifndef _StepData_SelectType_HeaderFile
#include <StepData_SelectType.hxx>
#endif
#ifndef _Standard_Integer_HeaderFile
#include <Standard_Integer.hxx>
#endif
#ifndef _Handle_Standard_Transient_HeaderFile
#include <Handle_Standard_Transient.hxx>
#endif
#ifndef _Handle_StepData_SelectMember_HeaderFile
#include <Handle_StepData_SelectMember.hxx>
#endif
#ifndef _Handle_TColStd_HArray1OfReal_HeaderFile
#include <Handle_TColStd_HArray1OfReal.hxx>
#endif
class Standard_Transient;
class StepData_SelectMember;
class TColStd_HArray1OfReal;


#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif
#ifndef _Standard_Macro_HeaderFile
#include <Standard_Macro.hxx>
#endif

//! Representation of STEP SELECT type SymmetricTensor43d <br>
class StepFEA_SymmetricTensor43d  : public StepData_SelectType {

public:

    void* operator new(size_t,void* anAddress) 
      {
        return anAddress;
      }
    void* operator new(size_t size) 
      { 
        return Standard::Allocate(size); 
      }
    void  operator delete(void *anAddress) 
      { 
        if (anAddress) Standard::Free((Standard_Address&)anAddress); 
      }
 // Methods PUBLIC
 // 

//! Empty constructor <br>
Standard_EXPORT StepFEA_SymmetricTensor43d();

//! return 0 <br>
Standard_EXPORT   Standard_Integer CaseNum(const Handle(Standard_Transient)& ent) const;

//! Recognizes a items of select member CurveElementFreedomMember <br>
//!          1 -> AnisotropicSymmetricTensor43d <br>
//!          2 -> FeaIsotropicSymmetricTensor43d <br>
//!          3 -> FeaIsoOrthotropicSymmetricTensor43d <br>
//!          4 -> FeaTransverseIsotropicSymmetricTensor43d <br>
//!          5 -> FeaColumnNormalisedOrthotropicSymmetricTensor43d <br>
//!          6 -> FeaColumnNormalisedMonoclinicSymmetricTensor43d <br>
//!          0 else <br>
Standard_EXPORT virtual  Standard_Integer CaseMem(const Handle(StepData_SelectMember)& ent) const;


Standard_EXPORT virtual  Handle_StepData_SelectMember NewMember() const;

//! Returns Value as AnisotropicSymmetricTensor43d (or Null if another type) <br>
Standard_EXPORT   Handle_TColStd_HArray1OfReal AnisotropicSymmetricTensor43d() const;


Standard_EXPORT   void SetFeaIsotropicSymmetricTensor43d(const Handle(TColStd_HArray1OfReal)& val) ;

//! Returns Value as FeaIsotropicSymmetricTensor43d (or Null if another type) <br>
Standard_EXPORT   Handle_TColStd_HArray1OfReal FeaIsotropicSymmetricTensor43d() const;

//! Returns Value as FeaIsoOrthotropicSymmetricTensor43d (or Null if another type) <br>
Standard_EXPORT   Handle_TColStd_HArray1OfReal FeaIsoOrthotropicSymmetricTensor43d() const;

//! Returns Value as FeaTransverseIsotropicSymmetricTensor43d (or Null if another type) <br>
Standard_EXPORT   Handle_TColStd_HArray1OfReal FeaTransverseIsotropicSymmetricTensor43d() const;

//! Returns Value as FeaColumnNormalisedOrthotropicSymmetricTensor43d (or Null if another type) <br>
Standard_EXPORT   Handle_TColStd_HArray1OfReal FeaColumnNormalisedOrthotropicSymmetricTensor43d() const;

//! Returns Value as FeaColumnNormalisedMonoclinicSymmetricTensor43d (or Null if another type) <br>
Standard_EXPORT   Handle_TColStd_HArray1OfReal FeaColumnNormalisedMonoclinicSymmetricTensor43d() const;





protected:

 // Methods PROTECTED
 // 


 // Fields PROTECTED
 //


private: 

 // Methods PRIVATE
 // 


 // Fields PRIVATE
 //


};





// other Inline functions and methods (like "C++: function call" methods)
//


#endif
