// File generated by CPPExt (Transient)
//
//
//                     Copyright (C) 1991 - 2000 by  
//                      Matra Datavision SA.  All rights reserved.
//  
//                     Copyright (C) 2001 - 2004 by
//                     Open CASCADE SA.  All rights reserved.
// 
// This file is part of the Open CASCADE Technology software.
//
// This software may be distributed and/or modified under the terms and
// conditions of the Open CASCADE Public License as defined by Open CASCADE SA
// and appearing in the file LICENSE included in the packaging of this file.
//  
// This software is distributed on an "AS IS" basis, without warranty of any
// kind, and Open CASCADE SA hereby disclaims all such warranties,
// including without limitation, any warranties of merchantability, fitness
// for a particular purpose or non-infringement. Please see the License for
// the specific terms and conditions governing rights and limitations under the
// License.

#ifndef _TopOpeBRepDS_ShapeShapeInterference_HeaderFile
#define _TopOpeBRepDS_ShapeShapeInterference_HeaderFile

#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif
#ifndef _Handle_TopOpeBRepDS_ShapeShapeInterference_HeaderFile
#include <Handle_TopOpeBRepDS_ShapeShapeInterference.hxx>
#endif

#ifndef _Standard_Boolean_HeaderFile
#include <Standard_Boolean.hxx>
#endif
#ifndef _TopOpeBRepDS_Config_HeaderFile
#include <TopOpeBRepDS_Config.hxx>
#endif
#ifndef _TopOpeBRepDS_Interference_HeaderFile
#include <TopOpeBRepDS_Interference.hxx>
#endif
#ifndef _TopOpeBRepDS_Kind_HeaderFile
#include <TopOpeBRepDS_Kind.hxx>
#endif
#ifndef _Standard_Integer_HeaderFile
#include <Standard_Integer.hxx>
#endif
#ifndef _Standard_OStream_HeaderFile
#include <Standard_OStream.hxx>
#endif
class TopOpeBRepDS_Transition;



class TopOpeBRepDS_ShapeShapeInterference : public TopOpeBRepDS_Interference {

public:
 // Methods PUBLIC
 // 

//! a shape interfers on shape <G> with shape <S>. <br>
//! examples : <br>
//! create a ShapeShapeInterference describing : <br>
//! vertex V of edge E1 found on edge E2 : <br>
//! ST,S,GT,G = TopOpeBRepDS_EDGE,E2,TopOpeBRepDS_VERTEX,V <br>
//! <br>
//! create a ShapeShapeInterference describing <br>
//! vertex V of edge E found on face F : <br>
//! ST,S,GT,G = TopOpeBRepDS_FACE,F,TopOpeBRepDS_VERTEX,V <br>
Standard_EXPORT TopOpeBRepDS_ShapeShapeInterference(const TopOpeBRepDS_Transition& T,const TopOpeBRepDS_Kind ST,const Standard_Integer S,const TopOpeBRepDS_Kind GT,const Standard_Integer G,const Standard_Boolean GBound,const TopOpeBRepDS_Config C);


Standard_EXPORT   TopOpeBRepDS_Config Config() const;


Standard_EXPORT   Standard_Boolean GBound() const;


Standard_EXPORT   void SetGBound(const Standard_Boolean b) ;


Standard_EXPORT virtual  Standard_OStream& Dump(Standard_OStream& OS) const;
//Standard_EXPORT ~TopOpeBRepDS_ShapeShapeInterference();




 // Type management
 //
 Standard_EXPORT const Handle(Standard_Type)& DynamicType() const;
 //Standard_EXPORT Standard_Boolean	       IsKind(const Handle(Standard_Type)&) const;

protected:

 // Methods PROTECTED
 // 


 // Fields PROTECTED
 //


private: 

 // Methods PRIVATE
 // 


 // Fields PRIVATE
 //
Standard_Boolean myGBound;
TopOpeBRepDS_Config myC;


};





// other Inline functions and methods (like "C++: function call" methods)
//


#endif
