// File generated by CPPExt (Value)
//
//                     Copyright (C) 1991 - 2000 by  
//                      Matra Datavision SA.  All rights reserved.
//  
//                     Copyright (C) 2001 - 2004 by
//                     Open CASCADE SA.  All rights reserved.
// 
// This file is part of the Open CASCADE Technology software.
//
// This software may be distributed and/or modified under the terms and
// conditions of the Open CASCADE Public License as defined by Open CASCADE SA
// and appearing in the file LICENSE included in the packaging of this file.
//  
// This software is distributed on an "AS IS" basis, without warranty of any
// kind, and Open CASCADE SA hereby disclaims all such warranties,
// including without limitation, any warranties of merchantability, fitness
// for a particular purpose or non-infringement. Please see the License for
// the specific terms and conditions governing rights and limitations under the
// License.

#ifndef _TopOpeBRepDS_Surface_HeaderFile
#define _TopOpeBRepDS_Surface_HeaderFile

#ifndef _Handle_Geom_Surface_HeaderFile
#include <Handle_Geom_Surface.hxx>
#endif
#ifndef _Standard_Real_HeaderFile
#include <Standard_Real.hxx>
#endif
#ifndef _Standard_Boolean_HeaderFile
#include <Standard_Boolean.hxx>
#endif
class Geom_Surface;


#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif
#ifndef _Standard_Macro_HeaderFile
#include <Standard_Macro.hxx>
#endif

//! A Geom poimt and a tolerance. <br>
class TopOpeBRepDS_Surface  {

public:

    void* operator new(size_t,void* anAddress) 
      {
        return anAddress;
      }
    void* operator new(size_t size) 
      { 
        return Standard::Allocate(size); 
      }
    void  operator delete(void *anAddress) 
      { 
        if (anAddress) Standard::Free((Standard_Address&)anAddress); 
      }
 // Methods PUBLIC
 // 


Standard_EXPORT TopOpeBRepDS_Surface();


Standard_EXPORT TopOpeBRepDS_Surface(const Handle(Geom_Surface)& P,const Standard_Real T);


Standard_EXPORT TopOpeBRepDS_Surface(const TopOpeBRepDS_Surface& Other);


Standard_EXPORT   void Assign(const TopOpeBRepDS_Surface& Other) ;
  void operator=(const TopOpeBRepDS_Surface& Other) 
{
  Assign(Other);
}



Standard_EXPORT  const Handle_Geom_Surface& Surface() const;


Standard_EXPORT   Standard_Real Tolerance() const;

//! Update the tolerance <br>
Standard_EXPORT   void Tolerance(const Standard_Real tol) ;


Standard_EXPORT   Standard_Boolean Keep() const;


Standard_EXPORT   void ChangeKeep(const Standard_Boolean B) ;





protected:

 // Methods PROTECTED
 // 


 // Fields PROTECTED
 //


private: 

 // Methods PRIVATE
 // 


 // Fields PRIVATE
 //
Handle_Geom_Surface mySurface;
Standard_Real myTolerance;
Standard_Boolean myKeep;


};





// other Inline functions and methods (like "C++: function call" methods)
//


#endif
