// File generated by CPPExt (Value)
//
//                     Copyright (C) 1991 - 2000 by  
//                      Matra Datavision SA.  All rights reserved.
//  
//                     Copyright (C) 2001 - 2004 by
//                     Open CASCADE SA.  All rights reserved.
// 
// This file is part of the Open CASCADE Technology software.
//
// This software may be distributed and/or modified under the terms and
// conditions of the Open CASCADE Public License as defined by Open CASCADE SA
// and appearing in the file LICENSE included in the packaging of this file.
//  
// This software is distributed on an "AS IS" basis, without warranty of any
// kind, and Open CASCADE SA hereby disclaims all such warranties,
// including without limitation, any warranties of merchantability, fitness
// for a particular purpose or non-infringement. Please see the License for
// the specific terms and conditions governing rights and limitations under the
// License.

#ifndef _TopOpeBRepTool_CurveTool_HeaderFile
#define _TopOpeBRepTool_CurveTool_HeaderFile

#ifndef _TopOpeBRepTool_GeomTool_HeaderFile
#include <TopOpeBRepTool_GeomTool.hxx>
#endif
#ifndef _TopOpeBRepTool_OutCurveType_HeaderFile
#include <TopOpeBRepTool_OutCurveType.hxx>
#endif
#ifndef _Standard_Boolean_HeaderFile
#include <Standard_Boolean.hxx>
#endif
#ifndef _Standard_Real_HeaderFile
#include <Standard_Real.hxx>
#endif
#ifndef _Handle_Geom_Curve_HeaderFile
#include <Handle_Geom_Curve.hxx>
#endif
#ifndef _Handle_Geom2d_Curve_HeaderFile
#include <Handle_Geom2d_Curve.hxx>
#endif
class TopOpeBRepTool_GeomTool;
class Geom_Curve;
class Geom2d_Curve;
class TopoDS_Shape;
class TColgp_Array1OfPnt;
class TColgp_Array1OfPnt2d;


#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif
#ifndef _Standard_Macro_HeaderFile
#include <Standard_Macro.hxx>
#endif


class TopOpeBRepTool_CurveTool  {

public:

    void* operator new(size_t,void* anAddress) 
      {
        return anAddress;
      }
    void* operator new(size_t size) 
      { 
        return Standard::Allocate(size); 
      }
    void  operator delete(void *anAddress) 
      { 
        if (anAddress) Standard::Free((Standard_Address&)anAddress); 
      }
 // Methods PUBLIC
 // 


Standard_EXPORT TopOpeBRepTool_CurveTool();


Standard_EXPORT TopOpeBRepTool_CurveTool(const TopOpeBRepTool_OutCurveType OCT);


Standard_EXPORT TopOpeBRepTool_CurveTool(const TopOpeBRepTool_GeomTool& GT);


Standard_EXPORT   TopOpeBRepTool_GeomTool& ChangeGeomTool() ;


Standard_EXPORT  const TopOpeBRepTool_GeomTool& GetGeomTool() const;


Standard_EXPORT   void SetGeomTool(const TopOpeBRepTool_GeomTool& GT) ;

//! Approximates curves. <br>
//!          Returns False in the case of failure <br>
Standard_EXPORT   Standard_Boolean MakeCurves(const Standard_Real min,const Standard_Real max,const Handle(Geom_Curve)& C3D,const Handle(Geom2d_Curve)& PC1,const Handle(Geom2d_Curve)& PC2,const TopoDS_Shape& S1,const TopoDS_Shape& S2,Handle(Geom_Curve)& C3DN,Handle(Geom2d_Curve)& PC1N,Handle(Geom2d_Curve)& PC2N,Standard_Real& Tol3d,Standard_Real& Tol2d) const;


Standard_EXPORT static  Handle_Geom_Curve MakeBSpline1fromPnt(const TColgp_Array1OfPnt& P) ;


Standard_EXPORT static  Handle_Geom2d_Curve MakeBSpline1fromPnt2d(const TColgp_Array1OfPnt2d& P) ;


Standard_EXPORT static  Standard_Boolean IsProjectable(const TopoDS_Shape& S,const Handle(Geom_Curve)& C) ;


Standard_EXPORT static  Handle_Geom2d_Curve MakePCurveOnFace(const TopoDS_Shape& S,const Handle(Geom_Curve)& C,Standard_Real& TolReached2d,const Standard_Real first = 0.0,const Standard_Real last = 0.0) ;





protected:

 // Methods PROTECTED
 // 


 // Fields PROTECTED
 //
TopOpeBRepTool_GeomTool myGeomTool;


private: 

 // Methods PRIVATE
 // 


 // Fields PRIVATE
 //


};





// other Inline functions and methods (like "C++: function call" methods)
//


#endif
