// File generated by CPPExt (Value)
//
//                     Copyright (C) 1991 - 2000 by  
//                      Matra Datavision SA.  All rights reserved.
//  
//                     Copyright (C) 2001 - 2004 by
//                     Open CASCADE SA.  All rights reserved.
// 
// This file is part of the Open CASCADE Technology software.
//
// This software may be distributed and/or modified under the terms and
// conditions of the Open CASCADE Public License as defined by Open CASCADE SA
// and appearing in the file LICENSE included in the packaging of this file.
//  
// This software is distributed on an "AS IS" basis, without warranty of any
// kind, and Open CASCADE SA hereby disclaims all such warranties,
// including without limitation, any warranties of merchantability, fitness
// for a particular purpose or non-infringement. Please see the License for
// the specific terms and conditions governing rights and limitations under the
// License.

#ifndef _TopOpeBRep_EdgesFiller_HeaderFile
#define _TopOpeBRep_EdgesFiller_HeaderFile

#ifndef _TopoDS_Edge_HeaderFile
#include <TopoDS_Edge.hxx>
#endif
#ifndef _TopoDS_Face_HeaderFile
#include <TopoDS_Face.hxx>
#endif
#ifndef _Handle_TopOpeBRepDS_HDataStructure_HeaderFile
#include <Handle_TopOpeBRepDS_HDataStructure.hxx>
#endif
#ifndef _TopOpeBRepDS_PDataStructure_HeaderFile
#include <TopOpeBRepDS_PDataStructure.hxx>
#endif
#ifndef _TopOpeBRep_PEdgesIntersector_HeaderFile
#include <TopOpeBRep_PEdgesIntersector.hxx>
#endif
#ifndef _TopOpeBRepDS_ListOfInterference_HeaderFile
#include <TopOpeBRepDS_ListOfInterference.hxx>
#endif
#ifndef _Standard_Integer_HeaderFile
#include <Standard_Integer.hxx>
#endif
#ifndef _Standard_Boolean_HeaderFile
#include <Standard_Boolean.hxx>
#endif
#ifndef _TopOpeBRepDS_Kind_HeaderFile
#include <TopOpeBRepDS_Kind.hxx>
#endif
#ifndef _Handle_TopOpeBRepDS_Interference_HeaderFile
#include <Handle_TopOpeBRepDS_Interference.hxx>
#endif
#ifndef _Standard_Real_HeaderFile
#include <Standard_Real.hxx>
#endif
#ifndef _TopOpeBRepDS_Config_HeaderFile
#include <TopOpeBRepDS_Config.hxx>
#endif
class TopOpeBRepDS_HDataStructure;
class TopoDS_Shape;
class TopOpeBRep_EdgesIntersector;
class TopOpeBRepDS_ListIteratorOfListOfInterference;
class TopOpeBRep_Point2d;
class TopOpeBRepDS_Transition;
class TopOpeBRepDS_Interference;
class TopoDS_Edge;
class TopOpeBRepDS_ListOfInterference;


#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif
#ifndef _Standard_Macro_HeaderFile
#include <Standard_Macro.hxx>
#endif

//! Fills a TopOpeBRepDS_DataStructure with Edge/Edge <br>
//!          instersection data described by TopOpeBRep_EdgesIntersector. <br>
class TopOpeBRep_EdgesFiller  {

public:

    void* operator new(size_t,void* anAddress) 
      {
        return anAddress;
      }
    void* operator new(size_t size) 
      { 
        return Standard::Allocate(size); 
      }
    void  operator delete(void *anAddress) 
      { 
        if (anAddress) Standard::Free((Standard_Address&)anAddress); 
      }
 // Methods PUBLIC
 // 


Standard_EXPORT TopOpeBRep_EdgesFiller();


Standard_EXPORT   void Insert(const TopoDS_Shape& E1,const TopoDS_Shape& E2,TopOpeBRep_EdgesIntersector& EI,const Handle(TopOpeBRepDS_HDataStructure)& HDS) ;


Standard_EXPORT   void Face(const Standard_Integer I,const TopoDS_Shape& F) ;


Standard_EXPORT  const TopoDS_Shape& Face(const Standard_Integer I) const;





protected:

 // Methods PROTECTED
 // 


 // Fields PROTECTED
 //


private: 

 // Methods PRIVATE
 // 


Standard_EXPORT   Standard_Boolean GetGeometry(TopOpeBRepDS_ListIteratorOfListOfInterference& IT,const TopOpeBRep_Point2d& P,Standard_Integer& G,TopOpeBRepDS_Kind& K) const;


Standard_EXPORT   Standard_Boolean MakeGeometry(const TopOpeBRep_Point2d& P,Standard_Integer& G,TopOpeBRepDS_Kind& K) const;


Standard_EXPORT   void SetShapeTransition(const TopOpeBRep_Point2d& P,TopOpeBRepDS_Transition& T1,TopOpeBRepDS_Transition& T2) const;


Standard_EXPORT   Handle_TopOpeBRepDS_Interference StorePI(const TopOpeBRep_Point2d& P,const TopOpeBRepDS_Transition& T,const Standard_Integer EI,const Standard_Integer PI,const Standard_Real p,const Standard_Integer IE) ;


Standard_EXPORT   Handle_TopOpeBRepDS_Interference StoreVI(const TopOpeBRep_Point2d& P,const TopOpeBRepDS_Transition& T,const Standard_Integer EI,const Standard_Integer VI,const Standard_Boolean VB,const TopOpeBRepDS_Config C,const Standard_Real p,const Standard_Integer IE) ;


Standard_EXPORT   Standard_Boolean ToRecompute(const TopOpeBRep_Point2d& P,const Handle(TopOpeBRepDS_Interference)& I,const Standard_Integer IEmother) ;


Standard_EXPORT   void StoreRecompute(const Handle(TopOpeBRepDS_Interference)& I,const Standard_Integer IEmother) ;


Standard_EXPORT   void RecomputeInterferences(const TopoDS_Edge& E,TopOpeBRepDS_ListOfInterference& LOI) ;


 // Fields PRIVATE
 //
TopoDS_Edge myE1;
TopoDS_Edge myE2;
TopoDS_Face myF1;
TopoDS_Face myF2;
Handle_TopOpeBRepDS_HDataStructure myHDS;
TopOpeBRepDS_PDataStructure myPDS;
TopOpeBRep_PEdgesIntersector myPEI;
TopOpeBRepDS_ListOfInterference myLI1;
TopOpeBRepDS_ListOfInterference myLI2;


};





// other Inline functions and methods (like "C++: function call" methods)
//


#endif
