// File generated by CPPExt (Transient)
//
//
//                     Copyright (C) 1991 - 2000 by  
//                      Matra Datavision SA.  All rights reserved.
//  
//                     Copyright (C) 2001 - 2004 by
//                     Open CASCADE SA.  All rights reserved.
// 
// This file is part of the Open CASCADE Technology software.
//
// This software may be distributed and/or modified under the terms and
// conditions of the Open CASCADE Public License as defined by Open CASCADE SA
// and appearing in the file LICENSE included in the packaging of this file.
//  
// This software is distributed on an "AS IS" basis, without warranty of any
// kind, and Open CASCADE SA hereby disclaims all such warranties,
// including without limitation, any warranties of merchantability, fitness
// for a particular purpose or non-infringement. Please see the License for
// the specific terms and conditions governing rights and limitations under the
// License.

#ifndef _XSAlgo_AlgoContainer_HeaderFile
#define _XSAlgo_AlgoContainer_HeaderFile

#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif
#ifndef _Handle_XSAlgo_AlgoContainer_HeaderFile
#include <Handle_XSAlgo_AlgoContainer.hxx>
#endif

#ifndef _Handle_XSAlgo_ToolContainer_HeaderFile
#include <Handle_XSAlgo_ToolContainer.hxx>
#endif
#ifndef _MMgt_TShared_HeaderFile
#include <MMgt_TShared.hxx>
#endif
#ifndef _Standard_Real_HeaderFile
#include <Standard_Real.hxx>
#endif
#ifndef _Standard_CString_HeaderFile
#include <Standard_CString.hxx>
#endif
#ifndef _Handle_Standard_Transient_HeaderFile
#include <Handle_Standard_Transient.hxx>
#endif
#ifndef _Standard_Boolean_HeaderFile
#include <Standard_Boolean.hxx>
#endif
#ifndef _Handle_Transfer_TransientProcess_HeaderFile
#include <Handle_Transfer_TransientProcess.hxx>
#endif
#ifndef _Standard_Integer_HeaderFile
#include <Standard_Integer.hxx>
#endif
#ifndef _Handle_Transfer_FinderProcess_HeaderFile
#include <Handle_Transfer_FinderProcess.hxx>
#endif
class XSAlgo_ToolContainer;
class TopoDS_Shape;
class Standard_Transient;
class TopoDS_Edge;
class TopoDS_Face;
class Transfer_TransientProcess;
class Transfer_FinderProcess;



class XSAlgo_AlgoContainer : public MMgt_TShared {

public:
 // Methods PUBLIC
 // 

//! Empty constructor <br>
Standard_EXPORT XSAlgo_AlgoContainer();
//! Sets ToolContainer <br>
  void SetToolContainer(const Handle(XSAlgo_ToolContainer)& TC) ;
//! Returns ToolContainer <br>
  Handle_XSAlgo_ToolContainer ToolContainer() const;

//! Performs actions necessary for preparing environment <br>
//!          for transfer. Empty in Open version. <br>//! Applies fixes to the shape resulting from transfer, <br>
//!          and updates map of entity-shape in TP in accordance with <br>
//!          substitutions made during fixes (if any) <br>
Standard_EXPORT virtual  void PrepareForTransfer() const;

//! Does shape processing with specified tolerances <br>
//!          and returns resulting shape and associated information <br>
//!          in the form of Transient. <br>
//!          This information should be later transmitted to <br>
//!          MergeTransferInfo in order to be recorded in the <br>
//!          translation map <br>
Standard_EXPORT virtual  TopoDS_Shape ProcessShape(const TopoDS_Shape& shape,const Standard_Real Prec,const Standard_Real MaxTol,const Standard_CString rscfile,const Standard_CString seq,Handle(Standard_Transient)& info) const;

//! Checks quality of pcurve of the edge on the given face, <br>
//!          and corrects it if necessary. <br>
Standard_EXPORT virtual  Standard_Boolean CheckPCurve(const TopoDS_Edge& edge,const TopoDS_Face& face,const Standard_Real preci,const Standard_Boolean isSeam) const;


Standard_EXPORT virtual  void MergeTransferInfo(const Handle(Transfer_TransientProcess)& TP,const Handle(Standard_Transient)& info,const Standard_Integer startTPitem = 1) const;

//! Updates translation map (TP or FP) with information <br>
//!          resulting from ShapeProcessing <br>
//!          Parameter startTPitem can be used for optimisation, to <br>
//!          restrict modifications to entities stored in TP starting <br>
//!          from item startTPitem <br>
Standard_EXPORT virtual  void MergeTransferInfo(const Handle(Transfer_FinderProcess)& FP,const Handle(Standard_Transient)& info) const;
//Standard_EXPORT ~XSAlgo_AlgoContainer();




 // Type management
 //
 Standard_EXPORT const Handle(Standard_Type)& DynamicType() const;
 //Standard_EXPORT Standard_Boolean	       IsKind(const Handle(Standard_Type)&) const;

protected:

 // Methods PROTECTED
 // 


 // Fields PROTECTED
 //


private: 

 // Methods PRIVATE
 // 


 // Fields PRIVATE
 //
Handle_XSAlgo_ToolContainer myTC;


};


#include <XSAlgo_AlgoContainer.lxx>



// other Inline functions and methods (like "C++: function call" methods)
//


#endif
